//+------------------------------------------------------------------+
//|                                                   Compair EA.mq4 |
//|                                  Copyright 2024, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2024, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict


//Security Setting
string defaultPassword="Betkar-2018";   // chane password written 2 time

//expire date

//set Expire date

datetime expiryDate = D'2026.01.25 00:00'; //Year- Month-Day

//set Specific client Account number

int accountNumber=1234; //

enum stdir
  {
   b=2, // Normal
   c=1, // Reversal
  };

enum title_tfs
  {
   cur=0, // Current
   m1=1, // 1 Minute
   m5=5, // 5 Minutes
   m15=15, // 15 Minutes
   m30=30, // 30 Minutes
   h1=60, // 1 Hour
   h4=240, // 4 Hours
   d1=1440, // 1 Day
   w1=10080, // 1 Week
   mn1=43200  // 1 Month
  };

enum incdec
  {
   inc=1, // Increase
   nor=0, // Normal
   dec=-1, // Decrease
   rev=2, // Reverse
  };

enum extra
  {
   e1=1, // Increase
   e2=2, // Reverse
  };

enum custom_methods
  {
   a0=0, // Simple
   a1=1, // Exponential
   a2=2, // Smoothed
   a3=3, // Linear weighted
   a4=4, // Hull
  };

enum trigger
  {
   t0=0, // Off
   t1=1 // On
  };


//input string
bool   USE_INDICATORS_FROM_EA=true;
input string password="Betkar-2018";
extern string p04="--- LOGIC ---";
enum options
  {
   use_option_1,// logic 1
   use_option_2,// logic 2
   use_option_4, // logic 3
   use_option_6 //logic 4
  };
input options selectLogic=use_option_1; //Logic
extern stdir  Long_Type=2; // Type

extern string p01="-- LONG STRATEGY --";

// Increase the LEVEL / MOMENTUM / PRICE / AVERAGE to 6 input fields (currently, there are 3 for each).

extern double Long_Lots=0; // Lot size
extern double Long_TakeProfit=0; // Take Profit
extern double Long_StopLoss=0; // Stop Loss
//extern string p11="-- Filters --";

extern string p21="-- -- -- -- -- -- -- -- -- -- -- --";
//extern int    Long_Level_Start_(1)=0;
extern int    Long_Level_Start_One=0; // Level Start (1)
extern int    Long_Level_Finish_One=0; // Level Finish (1)
extern bool   Long_Level_Reverse_One=false; // Level Reverse (1)
extern int    Long_Level_Start_Two=0; // Level Start (2)
extern int    Long_Level_Finish_Two=0; // Level Finish (2)
extern bool   Long_Level_Reverse_Two=false; // Level Reverse (2)
extern int    Long_Level_Start_Three=0; // Level Start (3)
extern int    Long_Level_Finish_Three=0; // Level Finish (3)
extern bool   Long_Level_Reverse_Three=false; // Level Reverse (3)
extern int    Long_Level_Start_Four=0; // Level Start (4)
extern int    Long_Level_Finish_Four=0; // Level Finish (4)
extern bool   Long_Level_Reverse_Four=false; // Level Reverse (4)
extern int    Long_Level_Start_Five=0; // Level Start (5)
extern int    Long_Level_Finish_Five=0; // Level Finish (5)
extern bool   Long_Level_Reverse_Five=false; // Level Reverse (5)


extern string p31="-- -- -- -- -- -- -- -- -- -- -- --";
extern int    Long_Momentum_Start_One=0; // Momentum Start (1)
extern int    Long_Momentum_Finish_One=0; // Momentum Finish (1)
extern bool   Long_Momentum_Reverse_One=false; // Momentum Reverse (1)
extern int    Long_Momentum_Start_Two=0; // Momentum Start (2)
extern int    Long_Momentum_Finish_Two=0; // Momentum Finish (2)
extern bool   Long_Momentum_Reverse_Two=false; // Momentum Reverse (2)
extern int    Long_Momentum_Start_Three=0; // Momentum Start (3)
extern int    Long_Momentum_Finish_Three=0; // Momentum Finish (3)
extern bool   Long_Momentum_Reverse_Three=false; // Momentum Reverse (3)
extern int    Long_Momentum_Start_Four=0; // Momentum Start (4)
extern int    Long_Momentum_Finish_Four=0; // Momentum Finish (4)
extern bool   Long_Momentum_Reverse_Four=false; // Momentum Reverse (4)
extern int    Long_Momentum_Start_Five=0; // Momentum Start (5)
extern int    Long_Momentum_Finish_Five=0; // Momentum Finish (5)
extern bool   Long_Momentum_Reverse_Five=false; // Momentum Reverse (5)


extern string p41="-- -- -- -- -- -- -- -- -- -- -- --";
extern int    Long_Price_Start_One=0; // Price Start (1)
extern int    Long_Price_Finish_One=0; // Price Finish (1)
extern bool   Long_Price_Reverse_One=false; // Price Reverse (1)
extern int    Long_Price_Start_Two=0; // Price Start (2)
extern int    Long_Price_Finish_Two=0; // Price Finish (2)
extern bool   Long_Price_Reverse_Two=false; // Price Reverse (2)
extern int    Long_Price_Start_Three=0; // Price Start (3)
extern int    Long_Price_Finish_Three=0; // Price Finish (3)
extern bool   Long_Price_Reverse_Three=false; // Price Reverse (3)
extern int    Long_Price_Start_Four=0; // Price Start (4)
extern int    Long_Price_Finish_Four=0; // Price Finish (4)
extern bool   Long_Price_Reverse_Four=false; // Price Reverse (4)
extern int    Long_Price_Start_Five=0; // Price Start (5)
extern int    Long_Price_Finish_Five=0; // Price Finish (5)
extern bool   Long_Price_Reverse_Five=false; // Price Reverse (5)


extern string p51="-- -- -- -- -- -- -- -- -- -- -- --";
extern int    Long_Average_Start_One=0; // Average Start (1)
extern int    Long_Average_Finish_One=0; // Average Finish (1)
extern bool   Long_Average_Reverse_One=false; // Average Reverse (1)
extern int    Long_Average_Start_Two=0; // Average Start (2)
extern int    Long_Average_Finish_Two=0; // Average Finish (2)
extern bool   Long_Average_Reverse_Two=false; // Average Reverse (2)
extern int    Long_Average_Start_Three=0;// Average Start (3)
extern int    Long_Average_Finish_Three=0; // Average Finish (3)
extern bool   Long_Average_Reverse_Three=false; // Average Reverse (3)
extern int    Long_Average_Start_Four=0; // Average Start (4)
extern int    Long_Average_Finish_Four=0; // Average Finish (4)
extern bool   Long_Average_Reverse_Four=false; // Average Reverse (4)
extern int    Long_Average_Start_Five=0; // Average Start (5)
extern int    Long_Average_Finish_Five=0; // Average Finish (5)
extern bool   Long_Average_Reverse_Five=false; // Average Reverse (5)
extern int    Long_Average_Start_Six=0; // Average Start (6)
extern int    Long_Average_Finish_Six=0; // Average Finish (6)
extern bool   Long_Average_Reverse_Six=false; // Average Reverse (6)
extern int    Long_Average_Start_Seven=0; // Average Start (7)
extern int    Long_Average_Finish_Seven=0; // Average Finish (7)
extern bool   Long_Average_Reverse_Seven=false; // Average Reverse (7)
extern int    Long_Average_Start_Eight=0; // Average Start (8)
extern int    Long_Average_Finish_Eight=0; // Average Finish (8)
extern bool   Long_Average_Reverse_Eight=false; // Average Reverse (8)
extern int    Long_Average_Start_Nine=0; // Average Start (9)
extern int    Long_Average_Finish_Nine=0; // Average Finish (9)
extern bool   Long_Average_Reverse_Nine=false; // Average Reverse (9)


// "STC" BUY
extern string p61="-- SCHAFF TREND CYCLE - BUY --";

extern string p611 = "- settings 1 -";
//extern trigger STCB_TRIGGER_One=0; // Trigger (1)

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
extern trigger STCB_TRIGGER_One=0; // Trigger (1)
extern custom_methods STCB_METHOD_One=4; // Method (1)
extern ENUM_APPLIED_PRICE STCB_APPLY_One=PRICE_WEIGHTED; // Price (1)
extern double STCB_DIVISOR_One=1.2; // Divisor (1)
extern int    STCB_SHORT_One=0; // Short (1)
extern int    STCB_LONG_One=0; // Long (1)
extern int    STCB_CYCLE_One=0; // Cycle (1)
extern double STCB_LEVEL_One=20; // Level (1)

extern string p612 = "- settings 2 -";
extern trigger STCB_TRIGGER_Two=0; // Trigger (2)
extern custom_methods STCB_METHOD_Two=4; // Method (2)
extern ENUM_APPLIED_PRICE STCB_APPLY_Two=PRICE_WEIGHTED; // Price (2)
extern double STCB_DIVISOR_Two=1.2; // Divisor (2)
extern int    STCB_SHORT_Two=0; // Short (2)
extern int    STCB_LONG_Two=0; // Long (2)
extern int    STCB_CYCLE_Two=0; // Cycle (2)
extern double STCB_LEVEL_Two=20; // Level (2)
extern string p613 = "- settings 3 -";
extern trigger STCB_TRIGGER_Three=0; // Trigger (3)
extern custom_methods STCB_METHOD_Three=4; // Method (3)
extern ENUM_APPLIED_PRICE STCB_APPLY_Three=PRICE_WEIGHTED; // Price (3)
extern double STCB_DIVISOR_Three=1.2; // Divisor (3)
extern int    STCB_SHORT_Three=0; // Short (3)
extern int    STCB_LONG_Three=0; // Long (3)
extern int    STCB_CYCLE_Three=0; // Cycle (3)
extern double STCB_LEVEL_Three=20; // Level (3)
extern string p614 = "- settings 4 -";
extern trigger STCB_TRIGGER_Four=0; // Trigger (4)
extern custom_methods STCB_METHOD_Four=4; // Method (4)
extern ENUM_APPLIED_PRICE STCB_APPLY_Four=PRICE_WEIGHTED; // Price (4)
extern double STCB_DIVISOR_Four=1.2; // Divisor (4)
extern int    STCB_SHORT_Four=0; // Short (4)
extern int    STCB_LONG_Four=0; // Long (4)
extern int    STCB_CYCLE_Four=0; // Cycle (4)
extern double STCB_LEVEL_Four=20; // Level (4)
extern string p615 = "- settings 5 -";
extern trigger STCB_TRIGGER_Five=0; // Trigger (5)
extern custom_methods STCB_METHOD_Five=4; // Method (5)
extern ENUM_APPLIED_PRICE STCB_APPLY_Five=PRICE_WEIGHTED; // Price (5)
extern double STCB_DIVISOR_Five=1.2; // Divisor (5)
extern int    STCB_SHORT_Five=0; // Short (5)
extern int    STCB_LONG_Five=0; // Long (5)
extern int    STCB_CYCLE_Five=0; // Cycle (5)
extern double STCB_LEVEL_Five=20; // Level (5)


extern string p02="-- SHORT STRATEGY --";
int  Short_Type=2; // Type


extern double Short_Lots=0; // Lot size
extern double Short_TakeProfit=0; // Take Profit
extern double Short_StopLoss=0; // Stop Loss
//extern string p11="-- Filters --";

extern string p22="-- -- -- -- -- -- -- -- -- -- -- --";
extern int    Short_Level_Start_One=0; // Level Start (1)
extern int    Short_Level_Finish_One=0; // Level Finish (1)
extern bool   Short_Level_Reverse_One=false; // Level Reverse (1)
extern int    Short_Level_Start_Two=0; // Level Start (2)
extern int    Short_Level_Finish_Two=0; // Level Finish (2)
extern bool   Short_Level_Reverse_Two=false; // Level Reverse (2)
extern int    Short_Level_Start_Three=0; // Level Start (3)
extern int    Short_Level_Finish_Three=0; // Level Finish (3)
extern bool   Short_Level_Reverse_Three=false; // Level Reverse (3)
extern int    Short_Level_Start_Four=0; // Level Start (4)
extern int    Short_Level_Finish_Four=0; // Level Finish (4)
extern bool   Short_Level_Reverse_Four=false; // Level Reverse (4)
extern int    Short_Level_Start_Five=0; // Level Start (5)
extern int    Short_Level_Finish_Five=0; // Level Finish (5)
extern bool   Short_Level_Reverse_Five=false; // Level Reverse (5)


extern string p32="-- -- -- -- -- -- -- -- -- -- -- --";
extern int    Short_Momentum_Start_One=0; // Momentum Start (1)
extern int    Short_Momentum_Finish_One=0; // Momentum Finish (1)
extern bool   Short_Momentum_Reverse_One=false; // Momentum Reverse (1)
extern int    Short_Momentum_Start_Two=0; // Momentum Start (2)
extern int    Short_Momentum_Finish_Two=0; // Momentum Finish (2)
extern bool   Short_Momentum_Reverse_Two=false; // Momentum Reverse (2)
extern int    Short_Momentum_Start_Three=0; // Momentum Start (3)
extern int    Short_Momentum_Finish_Three=0; // Momentum Finish (3)
extern bool   Short_Momentum_Reverse_Three=false; // Momentum Reverse (3)
extern int    Short_Momentum_Start_Four=0; // Momentum Start (4)
extern int    Short_Momentum_Finish_Four=0; // Momentum Finish (4)
extern bool   Short_Momentum_Reverse_Four=false; // Momentum Reverse (4)
extern int    Short_Momentum_Start_Five=0; // Momentum Start (5)
extern int    Short_Momentum_Finish_Five=0; // Momentum Finish (5)
extern bool   Short_Momentum_Reverse_Five=false; // Momentum Reverse (5)


extern string p42="-- -- -- -- -- -- -- -- -- -- -- --";
extern int    Short_Price_Start_One=0; // Price Start (1)
extern int    Short_Price_Finish_One=0; // Price Finish (1)
extern bool   Short_Price_Reverse_One=false; // Price Reverse (1)
extern int    Short_Price_Start_Two=0; // Price Start (2)
extern int    Short_Price_Finish_Two=0; // Price Finish (2)
extern bool   Short_Price_Reverse_Two=false; // Price Reverse (2)
extern int    Short_Price_Start_Three=0; // Price Start (3)
extern int    Short_Price_Finish_Three=0; // Price Finish (3)
extern bool   Short_Price_Reverse_Three=false; // Price Reverse (3)
extern int    Short_Price_Start_Four=0; // Price Start (4)
extern int    Short_Price_Finish_Four=0; // Price Finish (4)
extern bool   Short_Price_Reverse_Four=false; // Price Reverse (4)
extern int    Short_Price_Start_Five=0; // Price Start (5)
extern int    Short_Price_Finish_Five=0; // Price Finish (5)
extern bool   Short_Price_Reverse_Five=false; // Price Reverse (5)


extern string p52="-- -- -- -- -- -- -- -- -- -- -- --";
extern int    Short_Average_Start_One=0; // Average Start (1)
extern int    Short_Average_Finish_One=0; // Average Finish (1)
extern bool   Short_Average_Reverse_One=false; // Average Reverse (1)
extern int    Short_Average_Start_Two=0; // Average Start (2)
extern int    Short_Average_Finish_Two=0; // Average Finish (2)
extern bool   Short_Average_Reverse_Two=false; // Average Reverse (2)
extern int    Short_Average_Start_Three=0;// Average Start (3)
extern int    Short_Average_Finish_Three=0; // Average Finish (3)
extern bool   Short_Average_Reverse_Three=false; // Average Reverse (3)
extern int    Short_Average_Start_Four=0; // Average Start (4)
extern int    Short_Average_Finish_Four=0; // Average Finish (4)
extern bool   Short_Average_Reverse_Four=false; // Average Reverse (4)
extern int    Short_Average_Start_Five=0; // Average Start (5)
extern int    Short_Average_Finish_Five=0; // Average Finish (5)
extern bool   Short_Average_Reverse_Five=false; // Average Reverse (5)
extern int    Short_Average_Start_Six=0; // Average Start (6)
extern int    Short_Average_Finish_Six=0; // Average Finish (6)
extern bool   Short_Average_Reverse_Six=false; // Average Reverse (6)
extern int    Short_Average_Start_Seven=0; // Average Start (7)
extern int    Short_Average_Finish_Seven=0; // Average Finish (7)
extern bool   Short_Average_Reverse_Seven=false; // Average Reverse (7)
extern int    Short_Average_Start_Eight=0; // Average Start (8)
extern int    Short_Average_Finish_Eight=0; // Average Finish (8)
extern bool   Short_Average_Reverse_Eight=false; // Average Reverse (8)
extern int    Short_Average_Start_Nine=0; // Average Start (9)
extern int    Short_Average_Finish_Nine=0; // Average Finish (9)
extern bool   Short_Average_Reverse_Nine=false; // Average Reverse (9)

// "STC" SELL
extern string pi4="-- SCHAFF TREND CYCLE - SELL --";
extern string p411 = "- settings 1 -";
extern trigger STCS_TRIGGER_One=0; // Trigger (1)
extern custom_methods STCS_METHOD_One=4; // Method (1)
extern ENUM_APPLIED_PRICE STCS_APPLY_One=PRICE_WEIGHTED; // Price (1)
extern double STCS_DIVISOR_One=1.2; // Divisor (1)
extern int    STCS_SHORT_One=0; // Short (1)
extern int    STCS_LONG_One=0; // Long (1)
extern int    STCS_CYCLE_One=0; // Cycle (1)
extern double STCS_LEVEL_One=80; // Level (1)
extern string p412 = "- settings 2 -";
extern trigger STCS_TRIGGER_Two=0; // Trigger (2)
extern custom_methods STCS_METHOD_Two=4; // Method (2)
extern ENUM_APPLIED_PRICE STCS_APPLY_Two=PRICE_WEIGHTED; // Price (2)
extern double STCS_DIVISOR_Two=1.2; // Divisor (2)
extern int    STCS_SHORT_Two=0; // Short (2)
extern int    STCS_LONG_Two=0; // Long (2)
extern int    STCS_CYCLE_Two=0; // Cycle (2)
extern double STCS_LEVEL_Two=80; // Level (2)
extern string p413 = "- settings 3 -";
extern trigger STCS_TRIGGER_Three=0; // Trigger (3)
extern custom_methods STCS_METHOD_Three=4; // Method (3)
extern ENUM_APPLIED_PRICE STCS_APPLY_Three=PRICE_WEIGHTED; // Price (3)
extern double STCS_DIVISOR_Three=1.2; // Divisor (3)
extern int    STCS_SHORT_Three=0; // Short (3)
extern int    STCS_LONG_Three=0; // Long (3)
extern int    STCS_CYCLE_Three=0; // Cycle (3)
extern double STCS_LEVEL_Three=80; // Level (3)
extern string p414 = "- settings 4 -";
extern trigger STCS_TRIGGER_Four=0; // Trigger (4)
extern custom_methods STCS_METHOD_Four=4; // Method (4)
extern ENUM_APPLIED_PRICE STCS_APPLY_Four=PRICE_WEIGHTED; // Price (4)
extern double STCS_DIVISOR_Four=1.2; // Divisor (4)
extern int    STCS_SHORT_Four=0; // Short (4)
extern int    STCS_LONG_Four=0; // Long (4)
extern int    STCS_CYCLE_Four=0; // Cycle (4)
extern double STCS_LEVEL_Four=80; // Level (4)
extern string p415 = "- settings 5 -";
extern trigger STCS_TRIGGER_Five=0; // Trigger (5)
extern custom_methods STCS_METHOD_Five=4; // Method (5)
extern ENUM_APPLIED_PRICE STCS_APPLY_Five=PRICE_WEIGHTED; // Price (5)
extern double STCS_DIVISOR_Five=1.2; // Divisor (5)
extern int    STCS_SHORT_Five=0; // Short (5)
extern int    STCS_LONG_Five=0; // Long (5)
extern int    STCS_CYCLE_Five=0; // Cycle (5)
extern double STCS_LEVEL_Five=80; // Level (5)

extern string p0="--- MAIN SETTINGS ---";


extern incdec W1=0;   // Win 1
extern incdec W2=0;   // Win 2
extern incdec W3=0;   // Win 3
extern incdec W4=0;   // Win 4
extern incdec W5=0;   // Win 5
extern incdec W6=0;   // Win 6
extern incdec W7=0;   // Win 7
extern incdec W8=0;   // Win 8
extern incdec W9=0;   // Win 9
extern incdec W10=0;  // Win 10


extern incdec L1=0;   // Loss 1
extern incdec L2=0;   // Loss 2
extern incdec L3=0;   // Loss 3
extern incdec L4=0;   // Loss 4
extern incdec L5=0;   // Loss 5
extern incdec L6=0;   // Loss 6
extern incdec L7=0;   // Loss 7
extern incdec L8=0;   // Loss 8
extern incdec L9=0;   // Loss 9
extern incdec L10=0;  // Loss 10

extern string p05="--- SPREAD FILtER ---";
extern bool   Spread_Filter=false;// Spread Filter
extern double Minutes_2=0; // Spread for 0-2 minutes
extern double Minutes_4=0; // Spread for 2-4 minutes
extern double Minutes_6=0; // Spread for 4-6 minutes
extern double Minutes_8=0; // Spread for 6-8 minutes
extern double Minutes_10=0; // Spread for 8-10 minutes
extern double Minutes_12=0; // Spread for 10-12 minutes


extern string p06="--- OTHER SETTINGS ---";


extern string Pair_Name_x=""; // Symbol
extern title_tfs Time_Frame=0; // Time Frame
extern int    MagicNumber=20220223; // Magic Number



string Pair_Name;
bool   Display_Dashboard=false; // Display Dashboard
int    MagicNumber2=0;
int    MagicNumber3=0;

int    WinIncrease=12;
int    LossIncrease=12;



int      Sets_Start[101];
//double   Poin;
string   com="Forextan EA_v2.6";
int      Slippage = 3;
double   vpl;
datetime New_Time;
string   GV_Strat;

//const int LEVEL_COUNT = 6;
//const int MOMENTUM_COUNT = 6;
//const int PRICE_COUNT = 10;
//const int AVERAGE_COUNT = 20;

#define LEVEL_COUNT 6
#define MOMENTUM_COUNT 6
#define PRICE_COUNT 10
#define AVERAGE_COUNT 20
#define STC_COUNT 10
#define ARRAY_SIZE 3

double Poin[3];
double Mins[8];

int Win_Increase[13];
int Loss_Increase[13];



int Level_Start[ARRAY_SIZE][LEVEL_COUNT+1];
int Level_Finish[ARRAY_SIZE][LEVEL_COUNT+1];
bool Level_Reverse[ARRAY_SIZE][LEVEL_COUNT+1];

int Momentum_Start[ARRAY_SIZE][MOMENTUM_COUNT+1];
int Momentum_Finish[ARRAY_SIZE][MOMENTUM_COUNT+1];
bool Momentum_Reverse[ARRAY_SIZE][MOMENTUM_COUNT+1];

int Price_Start[ARRAY_SIZE][PRICE_COUNT+1];
int Price_Finish[ARRAY_SIZE][PRICE_COUNT+1];
bool Price_Reverse[ARRAY_SIZE][PRICE_COUNT+1];

int Average_Start[ARRAY_SIZE][AVERAGE_COUNT+1];
int Average_Finish[ARRAY_SIZE][AVERAGE_COUNT+1];
bool Average_Reverse[ARRAY_SIZE][AVERAGE_COUNT+1];

string Pair_Ar[ARRAY_SIZE];
//double Poin_Ar[31];

double Lots_Ar[ARRAY_SIZE];
double TakeProfit_Ar[ARRAY_SIZE];
double StopLoss_Ar[ARRAY_SIZE];

//bool Reverse_Main_Ar[31];
//bool Off_Ar[31];

//stdir  Long_Type, Short_Type, Three_Type, Four_Type;

stdir Type_Ar[31];

bool even_one;


string        array[];
double        deposit;
datetime      Init_Deposit_Time=0;
double        wins;
double        monthly;
string        AccNum;
string        path="C:\\";
string        AccountInfo[][22];
string        Total[1][22];
string        sub;
int           AccCount;
datetime      TBUY, TSELL;

ENUM_TIMEFRAMES tf;

//string GV_Buy_Win, GV_Buy_Loss, GV_Sell_Win, GV_Sell_Loss;
//string GV_Buy_Win_DEC, GV_Buy_Loss_DEC, GV_Sell_Win_DEC, GV_Sell_Loss_DEC;

string GV_Base;

string GV_Buy_TP, GV_Buy_SL, GV_Sell_TP, GV_Sell_SL;

string GV_Win, GV_Loss;//, GV_Win_DEC, GV_Loss_DEC;

string GV_Extra_W1, GV_Extra_W2, GV_Extra_W3, GV_Extra_W4, GV_Extra_W5, GV_Extra_W6,
       GV_Extra_L1, GV_Extra_L2, GV_Extra_L3, GV_Extra_L4, GV_Extra_L5, GV_Extra_L6;

int count_for_extra=0;
double Lot_for_extra=0;
//bool rev_for_extra=false;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int countAble=0;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime matchTime;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {

   if(Pair_Name_x!="")
     {
      Pair_Name=Pair_Name_x;
     }
   else
     {
      Pair_Name=_Symbol;
     }



   if(defaultPassword!=password)
     {
      Alert("Enter Password Wrong!");
      ExpertRemove();
     }

   if(TimeCurrent() > expiryDate)
     {
      Alert("Bot Expired!");
      return INIT_FAILED;
     }

   if(AccountNumber()!= accountNumber)
     {
      Alert("Account Number Invalid!");
      return INIT_FAILED;
     }


   if(selectLogic==use_option_4)// Logic 3
     {
      countAble=2;
     }
   if(selectLogic==use_option_6) // Logic 4
     {
      countAble=3;
     }

   Short_Type=Long_Type;
// set default value for MN2 and MN3
   MagicNumber2=MagicNumber+1;
   MagicNumber3=MagicNumber+2;

   tf=(ENUM_TIMEFRAMES) Time_Frame;
//tf=(int) Time_Frame;

// value per pip
//vpl = (1*Poin) / MarketInfo(Symbol(), MODE_TICKSIZE) * MarketInfo(Symbol(), MODE_TICKVALUE);

   if(IsTesting())
      New_Time=0;
   else
      New_Time=iTime(NULL, tf, 0);

   int i;

// check Pair_Name
   if(Pair_Name=="")
      Pair_Name=Symbol();

// set GV name
//GV_Strat=com+"_"+Symbol()+"_"+MagicNumber+"_Strat";
//if (GlobalVariableGet(GV_Strat)==0) GlobalVariableSet(GV_Strat, 1);

// set GVs' names
   /*
   GV_Buy_Win=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Buy_Win";
   GV_Buy_Loss=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Buy_Loss";
   GV_Sell_Win=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Sell_Win";
   GV_Sell_Loss=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Sell_Loss";

   GV_Buy_Win_DEC=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Buy_Win_DEC";
   GV_Buy_Loss_DEC=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Buy_Loss_DEC";
   GV_Sell_Win_DEC=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Sell_Win_DEC";
   GV_Sell_Loss_DEC=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Sell_Loss_DEC";
   */
   GV_Base=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber);

   GV_Win=GV_Base+"_Win";
   GV_Loss=GV_Base+"_Loss";
//GV_Win_DEC=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Win_DEC";
//GV_Loss_DEC=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Loss_DEC";

   GV_Buy_TP=GV_Base+"_Buy_TP";
   GV_Buy_SL=GV_Base+"_Buy_SL";
   GV_Sell_TP=GV_Base+"_Sell_TP";
   GV_Sell_SL=GV_Base+"_Sell_SL";

   GV_Extra_W1=GV_Base+"_Extra_W1";
   GV_Extra_W2=GV_Base+"_Extra_W2";
   GV_Extra_W3=GV_Base+"_Extra_W3";
   GV_Extra_W4=GV_Base+"_Extra_W4";
   GV_Extra_W5=GV_Base+"_Extra_W5";
   GV_Extra_W6=GV_Base+"_Extra_W6";

   GV_Extra_L1=GV_Base+"_Extra_L1";
   GV_Extra_L2=GV_Base+"_Extra_L2";
   GV_Extra_L3=GV_Base+"_Extra_L3";
   GV_Extra_L4=GV_Base+"_Extra_L4";
   GV_Extra_L5=GV_Base+"_Extra_L5";
   GV_Extra_L6=GV_Base+"_Extra_L6";


// define arrays for strategies
   SetArrays();

//Print("Long_WI=", Long_WinIncrease, ", Long_LI=", Long_LossIncrease, ", Short_WI=", Short_WinIncrease, ", Short_LI=", Short_LossIncrease);

   /*
   for (int x=1; x<=30; x++)
      {
       int m=(int)MathFloor(x*15/120);
       Print("x*15=", x*15, ", m=", m);
      }
   */

   even_one=false;
   for(i=1; i<=2; i++)
      if(Type_Ar[i]>=1)
        {
         even_one=true;
         break;
        }

// if DASHBOARD
   if(Display_Dashboard)
     {
      deposit=0;
      if(!IsTesting())
        {
         for(i=0; i<OrdersHistoryTotal(); i++)
           {
            if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
               continue;
            if(OrderType()<=OP_SELLSTOP)
               continue;
            deposit=OrderProfit();
            Init_Deposit_Time=OrderOpenTime();
            break;
           }
         if(deposit==0)
           {
            deposit=AccountBalance();
            Init_Deposit_Time=TimeCurrent();
           }
        }
      else
         if(IsTesting())
           {
            deposit=AccountBalance();
            Init_Deposit_Time=TimeCurrent();
           }
     }





   return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//if (IsTesting()) GlobalVariableDel(GV_Strat);



// delete GV
   if(IsTesting())
     {
      /*
      GlobalVariableDel(GV_Buy_Win);
      GlobalVariableDel(GV_Buy_Loss);
      GlobalVariableDel(GV_Sell_Win);
      GlobalVariableDel(GV_Sell_Loss);

      GlobalVariableDel(GV_Buy_Win_DEC);
      GlobalVariableDel(GV_Buy_Loss_DEC);
      GlobalVariableDel(GV_Sell_Win_DEC);
      GlobalVariableDel(GV_Sell_Loss_DEC);
      */
      GlobalVariablesDeleteAll(GV_Base);

      //GlobalVariableDel(GV_Win);
      //GlobalVariableDel(GV_Loss);
      //GlobalVariableDel(GV_Win_DEC);
      //GlobalVariableDel(GV_Loss_DEC);

      //GlobalVariableDel(GV_Buy_TP);
      //GlobalVariableDel(GV_Buy_SL);
      //GlobalVariableDel(GV_Sell_TP);
      //GlobalVariableDel(GV_Sell_SL);
     }

   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
bool option_1=false;
bool option_2=false;
bool option_4=false;
bool option_6=false;

bool option_1_s=false;
bool option_2_s=false;
bool option_4_s=false;
bool option_6_s=false;


bool okfine_s=false;
bool okfine_s_2=false;

bool okfine=false;
bool okfine_2=false;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetMaxValue(double &array[], int arraySize)
  {
   if(arraySize <= 0)
      return EMPTY_VALUE; // Handle empty array case

   double maxValue = array[0]; // Assume the first element is the max initially
   for(int i = 1; i < arraySize; i++)
     {
      if(array[i] > maxValue)
        {
         maxValue = array[i]; // Update max value if a larger value is found
        }
     }
   return maxValue;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {



// check even_one
   if(!even_one)
     {
      // Comment("Set even 1 strategy ON");
      return(0);
     }
   else
      // Comment("");

      // close EXTRA if closed ORIGINAL
      //Print("OC = ", OrderCount(Pair_Name, -1), ", OCTrue = ", OrderCount(Pair_Name, -1, true));
      if(OrderCount(Pair_Name, -1)==0 && OrderCount(Pair_Name, -1, true)==0)
        {
         //Print("HE HE HE");
         //Print("OC1 = ", OrderCountExtr(Pair_Name, 1), ", OC0 = ", OrderCountExtr(Pair_Name, 0));
         // close EXTRA orders
         while(OrderCountExtr(Pair_Name,1)>0)
            CloseOrdExtr(Pair_Name,1);
         while(OrderCountExtr(Pair_Name,0)>0)
            CloseOrdExtr(Pair_Name,0);
        }

// check SL/TP if Spread_Filter is ON
   if(Spread_Filter)
      CheckOrdersBySpread();



// check new bar
   if(!New_Candle())
      return(0);

   /*
   // close orders if new candle appeared
   if (OrderCount(Pair_Name, -1)>0 || OrderCount(Pair_Name, -1, true)>0)
      {
       // close orders
       while (OrderCount(Pair_Name,0)>0) CloseOrd(Pair_Name,0);
       while (OrderCount(Pair_Name,1)>0) CloseOrd(Pair_Name,1);
       // close REV orders
       while (OrderCount(Pair_Name,0,true)>0) CloseOrd(Pair_Name,0,true);
       while (OrderCount(Pair_Name,1,true)>0) CloseOrd(Pair_Name,1,true);
      }
   */

// check last order was closed with loss or profit
//if (OrderCount(-1)==0) CheckLast();

//int n=GlobalVariableGet(GV_Strat);
//bool Carry_Trade=Carry_Trade_Ar[n];

   int symtotal=SymbolsTotal(false);
// CYCLE to check EVERY 5 pairs
   for(int n=1; n<=2; n++)
     {

      // check ON/OFF
      //if (Type_Ar[n]==0) continue;

      // define PAIR
      string pair=Pair_Ar[n];
      bool exist=false;
      for(int k=0; k<symtotal; k++)
        {
         string sname=SymbolName(k,false);
         if(sname==pair)
           {
            exist=true;
            break;
           }
        }
      // check exist
      if(!exist)
         continue;

      int cmd=-1;
      if(selectLogic==use_option_1)
        {
         // last candle type
         int last=CheckBB(pair, 1);
         int i, j;
         double cl1=iClose(pair, tf, 1);
         double cl2=iClose(pair, tf, 2);
         //double clprice=0;
         double opprice=0;

         //bool just_closed=false;

         // for BULL
         if(last==0)
           {
            // 1st cycle
            for(i=1; i<iBars(pair, tf); i++)
              {
               // define END of previous SET
               if(CheckBB(pair,i)!=CheckBB(pair,i+1))
                 {
                  // 2nd cycle
                  for(j=i+1; j<iBars(pair,tf); j++)
                    {
                     // define END of previous SET
                     if(CheckBB(pair,j)!=CheckBB(pair,j+1))
                       {
                        opprice=iOpen(pair, tf, j);
                        break;
                       }
                    }
                  break;
                 }
              }

            // check result
            if(opprice>0.0 && NormalizeDouble(cl1, (int)MarketInfo(pair, MODE_DIGITS))>NormalizeDouble(opprice, (int)MarketInfo(pair, MODE_DIGITS)) &&
               NormalizeDouble(cl2, (int)MarketInfo(pair, MODE_DIGITS))<=NormalizeDouble(opprice, (int)MarketInfo(pair, MODE_DIGITS)))
               cmd=0;
           }
         // for BEAR
         else
            if(last==1)
              {
               // 1st cycle
               for(i=1; i<iBars(pair,tf); i++)
                 {
                  // define END of previous SET
                  if(CheckBB(pair,i)!=CheckBB(pair,i+1))
                    {
                     // 2nd cycle
                     for(j=i+1; j<iBars(pair,tf); j++)
                       {
                        // define END of previous SET
                        if(CheckBB(pair,j)!=CheckBB(pair,j+1))
                          {
                           opprice=iOpen(pair, tf, j);
                           break;
                          }
                       }
                     break;
                    }
                 }

               // check result
               if(opprice>0.0 && NormalizeDouble(cl1, (int)MarketInfo(pair, MODE_DIGITS))<NormalizeDouble(opprice, (int)MarketInfo(pair, MODE_DIGITS)) &&
                  NormalizeDouble(cl2, (int)MarketInfo(pair, MODE_DIGITS))>=NormalizeDouble(opprice, (int)MarketInfo(pair, MODE_DIGITS)))
                  cmd=1;
              }

         // check REVERSE
         if(cmd>-1 && Type_Ar[n]==2)
            cmd=!cmd;
         // check REVERSE for OFF
         if(cmd>-1 && Type_Ar[n]==0)
           {
            if((n==1 && Type_Ar[2]==2) || (n==2 && Type_Ar[1]==2))
               cmd=!cmd;
           }

         // for BUY
         if(cmd==0 && n==1)
           {
            // check open orders
            if(OrderCount(pair,0)==0 && OrderCount(pair,1,true)==0)
              {
               if(Filter(pair, 0, n))
                 {

                  option_1=true;

                  if(selectLogic==use_option_1)
                    {
                     // check Trade Overlap
                     //if (Check_TO(pair, 1))
                     while(OrderCount(pair,1)>0)
                        CloseOrd(pair,1); //just_closed=true; }
                     while(OrderCount(pair,0,true)>0)
                        CloseOrd(pair,0,true); //just_closed=true; }

                     // close EXTRA orders
                     while(OrderCountExtr(pair,1)>0)
                        CloseOrdExtr(pair,1);
                     while(OrderCountExtr(pair,0)>0)
                        CloseOrdExtr(pair,0);

                     // check Win/Loss increase
                     Check_WL(pair, -1);
                     //Check_WL(pair, 0);
                     //Check_WL(pair, 1);
                     OpenOrd(pair,0, n);
                    }

                 }
              }
           }
         // for SELL
         else
            if(cmd==1 && n==2)
              {
               // check open orders
               if(OrderCount(pair,1)==0 && OrderCount(pair,0,true)==0)
                 {
                  if(Filter(pair, 1, n))
                    {
                     option_1_s=true;

                     if(selectLogic==use_option_1)
                       {
                        while(OrderCount(pair,0)>0)
                           CloseOrd(pair,0); //just_closed=true; }
                        while(OrderCount(pair,1,true)>0)
                           CloseOrd(pair,1,true); //just_closed=true; }

                        // close EXTRA orders
                        while(OrderCountExtr(pair,1)>0)
                           CloseOrdExtr(pair,1);
                        while(OrderCountExtr(pair,0)>0)
                           CloseOrdExtr(pair,0);
                        // check Win/Loss increase
                        Check_WL(pair, -1);
                        OpenOrd(pair,1,n);
                       }
                    }
                 }
              }
        }

      static bool breaks=false;
      static bool breaksx=false;
      static int count=0;
      static int count_s=0;

      int lastBullish_index=iBarShift(_Symbol,PERIOD_CURRENT,GetLastBullishAfterBearish(50));
      int lastBearish_index=iBarShift(_Symbol,PERIOD_CURRENT,GetLastBearishAfterBearish(50));



      if(selectLogic==use_option_4 || selectLogic==use_option_6)
        {

         if(Time[lastBearish_index]<Time[1] && Open[lastBearish_index]<Close[1]&& Close[1]>Open[1])
           {

            if(count_s<=countAble-1) // reset Sell
              {
               count_s=0;
               breaksx=false;
              }

            static datetime time;
            if(time!=Time[0])
              {
               breaks=true;
               time=Time[0];
              }
           }

         if(Time[lastBearish_index]<Time[2] && Open[lastBearish_index]>Close[2]&& Close[2]>=Open[2] &&  Close[1]<Open[1])
           {
            count=0;
            breaks=false;
           }

         if(breaks && Close[1]<Open[1])
           {

            static datetime time;
            if(time!=Time[0])
              {
               count=count+1;
               breaks=false;
               time=Time[0];
              }
           }


         if(Time[2]>Time[lastBullish_index] && Open[lastBullish_index]<Close[2] && Close[2]<=Open[2] && Close[1]>Open[1])
           {
            ObjectsDeleteAll(0,"xs");
            count_s=0;
            breaksx=false;
           }

         //Sell
         if(Time[1]>Time[lastBullish_index] && Open[lastBullish_index]>Close[1] && Close[1]<Open[1])
           {

            if(count<=countAble-1)// Reset Buy
              {
               count=0;
               breaks=false;
              }


            static datetime time;
            if(time!=Time[0])
              {
               breaksx=true;
               time=Time[0];
              }
           }


         if(breaksx && Close[1]>Open[1])
           {

            static datetime time;
            if(time!=Time[0])
              {
               count_s=count_s+1;
               breaksx=false;
               time=Time[0];
              }
           }



         if(count>=countAble)
           {
            // rev

            if((cmd==1 || cmd==-1) && n==2 &&  Long_Type==2)
              {
               // check open orders
               if(OrderCount(pair,1)==0 && OrderCount(pair,0,true)==0 && Filter(pair, 1, n))
                 {
                  cmd==0;
                  count=0;
                  //  ObjectsDeleteAll(0,"v1");
                  while(OrderCount(pair,0)>0)
                     CloseOrd(pair,0); //just_closed=true; }
                  while(OrderCount(pair,1,true)>0)
                     CloseOrd(pair,1,true); //just_closed=true; }

                  // close EXTRA orders
                  while(OrderCountExtr(pair,1)>0)
                     CloseOrdExtr(pair,1);
                  while(OrderCountExtr(pair,0)>0)
                     CloseOrdExtr(pair,0);
                  // check Win/Loss increase
                  Check_WL(pair, -1);
                  OpenOrd(pair,1,n);
                 }
              }



            //Normal
            if((cmd==0 || cmd==-1) && n==1 && Long_Type==1)
              {
               // check open orders
               if(OrderCount(pair,0)==0 && OrderCount(pair,1,true)==0 && Filter(pair, 0, n))
                 {

                  cmd==1;
                  count=0;

                  while(OrderCount(pair,1)>0)
                     CloseOrd(pair,1); //just_closed=true; }
                  while(OrderCount(pair,0,true)>0)
                     CloseOrd(pair,0,true); //just_closed=true; }

                  // close EXTRA orders
                  while(OrderCountExtr(pair,1)>0)
                     CloseOrdExtr(pair,1);
                  while(OrderCountExtr(pair,0)>0)
                     CloseOrdExtr(pair,0);

                  // check Win/Loss increase
                  Check_WL(pair, -1);

                  OpenOrd(pair,0, n);

                 }
              }
           }


         if(count_s>=countAble)
           {

            if((cmd==1 || cmd==-1) && n==2 && Long_Type==1) // normal
              {
               // check open orders
               if(OrderCount(pair,1)==0 && OrderCount(pair,0,true)==0 && Filter(pair, 1, n))
                 {
                  cmd==0;
                  count_s=0;
                  //  ObjectsDeleteAll(0,"v1");
                  while(OrderCount(pair,0)>0)
                     CloseOrd(pair,0); //just_closed=true; }
                  while(OrderCount(pair,1,true)>0)
                     CloseOrd(pair,1,true); //just_closed=true; }

                  // close EXTRA orders
                  while(OrderCountExtr(pair,1)>0)
                     CloseOrdExtr(pair,1);
                  while(OrderCountExtr(pair,0)>0)
                     CloseOrdExtr(pair,0);

                  Check_WL(pair, -1);
                  OpenOrd(pair,1,n);

                 }
              }

            //

            if((cmd==0 || cmd==-1) && n==1 && Long_Type==2)
              {
               // check open orders
               if(OrderCount(pair,0)==0 && OrderCount(pair,1,true)==0 && Filter(pair, 0, n))
                 {
                  cmd==1;
                  count_s=0;
                  while(OrderCount(pair,1)>0)
                     CloseOrd(pair,1); //just_closed=true; }
                  while(OrderCount(pair,0,true)>0)
                     CloseOrd(pair,0,true); //just_closed=true; }

                  // close EXTRA orders
                  while(OrderCountExtr(pair,1)>0)
                     CloseOrdExtr(pair,1);
                  while(OrderCountExtr(pair,0)>0)
                     CloseOrdExtr(pair,0);
                  Check_WL(pair, -1);
                  OpenOrd(pair,0, n);

                 }
              }

           }
        }



      if(selectLogic==use_option_2)
        {

         if((cmd==0 || cmd==-1) && n==1)
           {

            // check open orders
            if(OrderCount(pair,0)==0 && OrderCount(pair,1,true)==0 && Filter(pair, 0, n))
              {

               if(Long_Type==2)
                 {
                  if(Time[1]>Time[lastBullish_index] && NormalizeDouble(Open[lastBullish_index],_Digits)>NormalizeDouble(Close[1],_Digits) && Close[1]<Open[1])
                    {
                     breaksx=true;
                    }
                 }
               else
                 {
                  if(Time[lastBearish_index]<Time[1] && Open[lastBearish_index]<Close[1] && Close[1]>Open[1])
                    {
                     breaksx=true;
                    }
                 }
               bool check=Long_Type==2 ?Close[1]>Open[1] : Close[1]<Open[1];

               if(breaksx && check)
                 {

                  breaksx=false;

                  cmd==1;

                  // check Trade Overlap
                  //if (Check_TO(pair, 1))
                  while(OrderCount(pair,1)>0)
                     CloseOrd(pair,1); //just_closed=true; }
                  while(OrderCount(pair,0,true)>0)
                     CloseOrd(pair,0,true); //just_closed=true; }

                  // close EXTRA orders
                  while(OrderCountExtr(pair,1)>0)
                     CloseOrdExtr(pair,1);
                  while(OrderCountExtr(pair,0)>0)
                     CloseOrdExtr(pair,0);

                  // check Win/Loss increase
                  Check_WL(pair, -1);
                  //Check_WL(pair, 0);
                  //Check_WL(pair, 1);

                  OpenOrd(pair,0, n);
                 }
              }
           }


         lastBullish_index=iBarShift(_Symbol,PERIOD_CURRENT,GetLastBullishAfterBearish(50));
         lastBearish_index=iBarShift(_Symbol,PERIOD_CURRENT,GetLastBearishAfterBearish(50));

         ///Sell Section
         if((cmd==1 || cmd==-1) && n==2)
           {
            // check open orders
            if(OrderCount(pair,1)==0 && OrderCount(pair,0,true)==0 && Filter(pair, 1, n))
              {

               if(Long_Type==2)
                 {
                  if(Time[lastBearish_index]<Time[1] && Open[lastBearish_index]<Close[1] && Close[1]>Open[1])
                    {
                     breaks=true;
                    }
                 }
               else
                 {
                  if(Time[1]>Time[lastBullish_index] && NormalizeDouble(Open[lastBullish_index],_Digits)>NormalizeDouble(Close[1],_Digits) && Close[1]<Open[1])
                    {
                     breaks=true;
                    }
                 }

               bool check=  Long_Type==2 ? Close[1]<Open[1]:Close[1]>Open[1];

               if(breaks && check)
                 {

                  breaks=false;

                  cmd==0;
                  while(OrderCount(pair,0)>0)
                     CloseOrd(pair,0); //just_closed=true; }
                  while(OrderCount(pair,1,true)>0)
                     CloseOrd(pair,1,true); //just_closed=true; }

                  // close EXTRA orders
                  while(OrderCountExtr(pair,1)>0)
                     CloseOrdExtr(pair,1);
                  while(OrderCountExtr(pair,0)>0)
                     CloseOrdExtr(pair,0);

                  // check Win/Loss increase
                  Check_WL(pair, -1);

                  OpenOrd(pair,1,n);

                 }


              }

           }


        }


     } // END of CYCLE!!!

// Comment(last);
   return(0);
  }

// define values
//beginopen=NormalizeDouble(MathAbs(iOpen(NULL, 0, Sets_Start[1])-iClose(NULL, 0, Sets_Start[1])), Digits); // 1st candle
//endclose=NormalizeDouble(MathAbs(iOpen(NULL, 0, Sets_Start[1]+1)-iClose(NULL, 0, Sets_Start[1]+1)), Digits); // previous candle

//+------------------------------------------------------------------+
//| Check orders for close with spread                               |
//+------------------------------------------------------------------+
void CheckOrdersBySpread()
  {
// define buy and sell counts
   int b=OrderCount(Pair_Ar[1], OP_BUY);
   int s=OrderCount(Pair_Ar[2], OP_SELL);

// for BUY
   if(b>0)
     {
      double sl=GlobalVariableGet(GV_Buy_SL);
      double tp=GlobalVariableGet(GV_Buy_TP);

      if(((tp>0 && NormalizeDouble(MarketInfo(Pair_Ar[1], MODE_BID), (int)MarketInfo(Pair_Ar[1], MODE_DIGITS))>=
           NormalizeDouble(tp, (int)MarketInfo(Pair_Ar[1], MODE_DIGITS))) ||
          (sl>0 && NormalizeDouble(MarketInfo(Pair_Ar[1], MODE_BID), (int)MarketInfo(Pair_Ar[1], MODE_DIGITS))<=
           NormalizeDouble(sl, (int)MarketInfo(Pair_Ar[1], MODE_DIGITS)))) && CheckSpread(OP_BUY))
        {
         GlobalVariableDel(GV_Buy_TP);
         GlobalVariableDel(GV_Buy_SL);
         CloseOrd(Pair_Ar[1], OP_BUY);
         // close EXTRA orders
         while(OrderCountExtr(Pair_Ar[1],1)>0)
            CloseOrdExtr(Pair_Ar[1],1);
         while(OrderCountExtr(Pair_Ar[1],0)>0)
            CloseOrdExtr(Pair_Ar[1],0);
        }
     }
// for SELL
   if(s>0)
     {
      double sl=GlobalVariableGet(GV_Sell_SL);
      double tp=GlobalVariableGet(GV_Sell_TP);

      if(((tp>0 && NormalizeDouble(MarketInfo(Pair_Ar[2], MODE_ASK), (int)MarketInfo(Pair_Ar[2], MODE_DIGITS))<=
           NormalizeDouble(tp, (int)MarketInfo(Pair_Ar[2], MODE_DIGITS))) ||
          (sl>0 && NormalizeDouble(MarketInfo(Pair_Ar[2], MODE_ASK), (int)MarketInfo(Pair_Ar[2], MODE_DIGITS))>=
           NormalizeDouble(sl, (int)MarketInfo(Pair_Ar[2], MODE_DIGITS)))) && CheckSpread(OP_SELL))
        {
         GlobalVariableDel(GV_Sell_TP);
         GlobalVariableDel(GV_Sell_SL);
         CloseOrd(Pair_Ar[2], OP_SELL);
         // close EXTRA orders
         while(OrderCountExtr(Pair_Ar[2],1)>0)
            CloseOrdExtr(Pair_Ar[2],1);
         while(OrderCountExtr(Pair_Ar[2],0)>0)
            CloseOrdExtr(Pair_Ar[2],0);
        }
     }

   return;
  }

//+------------------------------------------------------------------+
//| Check spread value                                               |
//+------------------------------------------------------------------+
bool CheckSpread(int cmd)
  {
   datetime t=0;
   int n=1;
   if(cmd==0)
     {
      t=TBUY;
      n=1;
     }
   else
      if(cmd==1)
        {
         t=TSELL;
         n=2;
        }
      else
         return(false);

   int m=(int)MathFloor((TimeCurrent()-t)/120);
// check spread
   double spr=MarketInfo(Pair_Ar[n], MODE_SPREAD)*MarketInfo(Pair_Ar[n], MODE_POINT);

// if MORE than 12 minutes
   if(m>=6)
      return(true);

// check ZERO
   if(Mins[m]<=0.0)
      return(true);

// check spread size
   if(spr>Mins[m]*Poin[n])
      return(false);
   else
      return(true);
  }

//+------------------------------------------------------------------+
//| Check Win Loss                                                   |
//+------------------------------------------------------------------+
bool Check_WL(string pair, int cmd)
  {
   datetime t=0;
   double res=0;

   /*
   // check BUY
   if (cmd==0)
     {
      res=LastOrderProfit(pair, cmd, t);
      if (res>0.0)
        {
         if (WinIncrease>0 && GlobalVariableGet(GV_Win)==0) GlobalVariableSet(GV_Win, t);
         //if (Win_Increase[1][1]>0 && GlobalVariableGet(GV_Buy_Win)==0) GlobalVariableSet(GV_Buy_Win, t);
        }
      if (res<0.0)
        {
         GlobalVariableDel(GV_Win);
         GlobalVariableDel(GV_Sell_Loss);
         if (Long_LossIncrease>0 && GlobalVariableGet(GV_Buy_Loss)==0) GlobalVariableSet(GV_Buy_Loss, t);
         //if (Loss_Increase[1][1]>0 && GlobalVariableGet(GV_Buy_Loss)==0) GlobalVariableSet(GV_Buy_Loss, t);
        }
     }
   // check SELL
   if (cmd==1)
     {
      res=LastOrderProfit(pair, cmd, t);
      //Print("SELL, res=", res);
      if (res>0.0)
        {
         if (Short_WinIncrease>0 && GlobalVariableGet(GV_Sell_Win)==0) GlobalVariableSet(GV_Sell_Win, t);
         //if (Win_Increase[2][1]>0 && GlobalVariableGet(GV_Sell_Win)==0) GlobalVariableSet(GV_Sell_Win, t);
        }
      if (res<0.0)
        {
         GlobalVariableDel(GV_Sell_Win);
         GlobalVariableDel(GV_Buy_Loss);
         if (Short_LossIncrease>0 && GlobalVariableGet(GV_Sell_Loss)==0) GlobalVariableSet(GV_Sell_Loss, t);
         //if (Loss_Increase[2][1]>0 && GlobalVariableGet(GV_Sell_Loss)==0) GlobalVariableSet(GV_Sell_Loss, t);
        }
     }
   */

   res=LastOrderProfit(pair, cmd, t);
//Print("RES = ", res);
   if(res>0.0)
     {
      GlobalVariableDel(GV_Loss);
      if(WinIncrease>0 && GlobalVariableGet(GV_Win)==0)
         GlobalVariableSet(GV_Win, t);
      //if (Win_Increase[1][1]>0 && GlobalVariableGet(GV_Buy_Win)==0) GlobalVariableSet(GV_Buy_Win, t);
     }
   if(res<0.0)
     {
      GlobalVariableDel(GV_Win);
      if(LossIncrease>0 && GlobalVariableGet(GV_Loss)==0)
         GlobalVariableSet(GV_Loss, t);
     }

// another case
   return(false);
  }

//+------------------------------------------------------------------+
//| Check Profit                                                     |
//+------------------------------------------------------------------+
double LastOrderProfit(string pair, int type, datetime &t)
  {
   int total = OrdersHistoryTotal();
   double res=0.0;

   for(int cnt=total-1; cnt>=0; cnt--)
     {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY))
         continue;
      if(OrderSymbol()!=pair && pair!="")
         continue;

      //if (OrderMagicNumber()!=MagicNumber) continue;
      if(OrderMagicNumber()!=MagicNumber && OrderMagicNumber()!=MagicNumber2)
         continue;

      //if (OrderOpenTime()<Start_Time) continue;
      if(OrderType() == type || type == -1)
        {
         res=res+OrderProfit()+OrderSwap()+OrderCommission();
         t=OrderCloseTime();

         // reverse RESULT for REVERSE order
         if(OrderMagicNumber()==MagicNumber2)
            res=res*(-1.0);

         return(res);
        }
     }

   return(res);
  }

/*
//+------------------------------------------------------------------+
//| Check Trade Overlap                                              |
//+------------------------------------------------------------------+
bool Check_TO(string pair, int cmd)
   {
    // close immediately
    if (Trade_Overlap==1) return(true);

    // wait naturally close
    else if (Trade_Overlap==2) return(false);

    // close if loss
    else if (Trade_Overlap==3 && Pr(pair, cmd)<=0.0) return(true);

    // close if profit
    else if (Trade_Overlap==4 && Pr(pair, cmd)>=0.0) return(true);

    // another case
    else return(false);
   }
*/

//+------------------------------------------------------------------+
//| Check Profit                                                     |
//+------------------------------------------------------------------+
double Pr(string pair, int type)
  {
   int total = OrdersTotal();
   double res=0.0;

   for(int cnt=0; cnt<total; cnt++)
     {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
         continue;
      if(OrderSymbol()!=pair && pair!="")
         continue;
      if(OrderMagicNumber()!=MagicNumber)
         continue;
      //if (OrderOpenTime()<Start_Time) continue;
      if(OrderType() == type || type == -1)
         res=res+OrderProfit()+OrderSwap()+OrderCommission();
     }

   return(res);
  }

//+------------------------------------------------------------------+
//| Check filters                                                    |
//+------------------------------------------------------------------+
bool Filter(string pair, int cmd, int n)
  {
// set DEFAULT values
//   int  Level_Start_1=Level_Start[n][1];
//   int  Level_Finish_1=Level_Finish[n][1];
//   bool Level_Reverse_1=Level_Reverse[n][1];
//   int  Level_Start_2=Level_Start[n][2];
//   int  Level_Finish_2=Level_Finish[n][2];
//   bool Level_Reverse_2=Level_Reverse[n][2];
//   int  Level_Start_3=Level_Start[n][3];
//   int  Level_Finish_3=Level_Finish[n][3];
//   bool Level_Reverse_3=Level_Reverse[n][3];
//   int  Level_Start_4=Level_Start[n][4];
//   int  Level_Finish_4=Level_Finish[n][4];
//   bool Level_Reverse_4=Level_Reverse[n][4];
//   int  Level_Start_5=Level_Start[n][5];
//   int  Level_Finish_5=Level_Finish[n][5];
//   bool Level_Reverse_5=Level_Reverse[n][5];
//   int  Level_Start_6=Level_Start[n][6];
//   int  Level_Finish_6=Level_Finish[n][6];
//   bool Level_Reverse_6=Level_Reverse[n][6];
//
//   int  Momentum_Start_1=Momentum_Start[n][1];
//   int  Momentum_Finish_1=Momentum_Finish[n][1];
//   bool Momentum_Reverse_1=Momentum_Reverse[n][1];
//   int  Momentum_Start_2=Momentum_Start[n][2];
//   int  Momentum_Finish_2=Momentum_Finish[n][2];
//   bool Momentum_Reverse_2=Momentum_Reverse[n][2];
//   int  Momentum_Start_3=Momentum_Start[n][3];
//   int  Momentum_Finish_3=Momentum_Finish[n][3];
//   bool Momentum_Reverse_3=Momentum_Reverse[n][3];
//   int  Momentum_Start_4=Momentum_Start[n][4];
//   int  Momentum_Finish_4=Momentum_Finish[n][4];
//   bool Momentum_Reverse_4=Momentum_Reverse[n][4];
//   int  Momentum_Start_5=Momentum_Start[n][5];
//   int  Momentum_Finish_5=Momentum_Finish[n][5];
//   bool Momentum_Reverse_5=Momentum_Reverse[n][5];
//   int  Momentum_Start_6=Momentum_Start[n][6];
//   int  Momentum_Finish_6=Momentum_Finish[n][6];
//   bool Momentum_Reverse_6=Momentum_Reverse[n][6];
//
//   int  Price_Start_1=Price_Start[n][1];
//   int  Price_Finish_1=Price_Finish[n][1];
//   bool Price_Reverse_1=Price_Reverse[n][1];
//   int  Price_Start_2=Price_Start[n][2];
//   int  Price_Finish_2=Price_Finish[n][2];
//   bool Price_Reverse_2=Price_Reverse[n][2];
//   int  Price_Start_3=Price_Start[n][3];
//   int  Price_Finish_3=Price_Finish[n][3];
//   bool Price_Reverse_3=Price_Reverse[n][3];
//   int  Price_Start_4=Price_Start[n][4];
//   int  Price_Finish_4=Price_Finish[n][4];
//   bool Price_Reverse_4=Price_Reverse[n][4];
//   int  Price_Start_5=Price_Start[n][5];
//   int  Price_Finish_5=Price_Finish[n][5];
//   bool Price_Reverse_5=Price_Reverse[n][5];
//   int  Price_Start_6=Price_Start[n][6];
//   int  Price_Finish_6=Price_Finish[n][6];
//   bool Price_Reverse_6=Price_Reverse[n][6];
//
//   int  Average_Start_1=Average_Start[n][1];
//   int  Average_Finish_1=Average_Finish[n][1];
//   bool Average_Reverse_1=Average_Reverse[n][1];
//   int  Average_Start_2=Average_Start[n][2];
//   int  Average_Finish_2=Average_Finish[n][2];
//   bool Average_Reverse_2=Average_Reverse[n][2];
//   int  Average_Start_3=Average_Start[n][3];
//   int  Average_Finish_3=Average_Finish[n][3];
//   bool Average_Reverse_3=Average_Reverse[n][3];
//   int  Average_Start_4=Average_Start[n][4];
//   int  Average_Finish_4=Average_Finish[n][4];
//   bool Average_Reverse_4=Average_Reverse[n][4];
//   int  Average_Start_5=Average_Start[n][5];
//   int  Average_Finish_5=Average_Finish[n][5];
//   bool Average_Reverse_5=Average_Reverse[n][5];
//   int  Average_Start_6=Average_Start[n][6];
//   int  Average_Finish_6=Average_Finish[n][6];
//   bool Average_Reverse_6=Average_Reverse[n][6];
//   int  Average_Start_7=Average_Start[n][7];
//   int  Average_Finish_7=Average_Finish[n][7];
//   bool Average_Reverse_7=Average_Reverse[n][7];
//   int  Average_Start_8=Average_Start[n][8];
//   int  Average_Finish_8=Average_Finish[n][8];
//   bool Average_Reverse_8=Average_Reverse[n][8];
//   int  Average_Start_9=Average_Start[n][9];
//   int  Average_Finish_9=Average_Finish[n][9];
//   bool Average_Reverse_9=Average_Reverse[n][9];
//   int  Average_Start_10=Average_Start[n][10];
//   int  Average_Finish_10=Average_Finish[n][10];
//   bool Average_Reverse_10=Average_Reverse[n][10];
//   int  Average_Start_11=Average_Start[n][11];
//   int  Average_Finish_11=Average_Finish[n][11];
//   bool Average_Reverse_11=Average_Reverse[n][11];
//   int  Average_Start_12=Average_Start[n][12];
//   int  Average_Finish_12=Average_Finish[n][12];
//   bool Average_Reverse_12=Average_Reverse[n][12];
//   int  Average_Start_13=Average_Start[n][13];
//   int  Average_Finish_13=Average_Finish[n][13];
//   bool Average_Reverse_13=Average_Reverse[n][13];
//   int  Average_Start_14=Average_Start[n][14];
//   int  Average_Finish_14=Average_Finish[n][14];
//   bool Average_Reverse_14=Average_Reverse[n][14];
//   int  Average_Start_15=Average_Start[n][15];
//   int  Average_Finish_15=Average_Finish[n][15];
//   bool Average_Reverse_15=Average_Reverse[n][15];


//string pair=Pair_Ar[n];

// check on/off for every filters type
   bool isLevel = false;
   for(int i = 1; i<= LEVEL_COUNT; i++)
     {
      if(Level_Start[n][i] && Level_Finish[n][i])
        {
         isLevel = true;
         break;
        }
     }

   bool isMomentum = false;
   for(int i = 1; i<= MOMENTUM_COUNT; i++)
     {
      if(Momentum_Start[n][i] && Momentum_Finish[n][i])
        {
         isMomentum = true;
         break;
        }
     }

   bool isPrice = false;
   for(int i = 1; i<= PRICE_COUNT; i++)
     {
      if(Price_Start[n][i] && Price_Finish[n][i])
        {
         isPrice = true;
         break;
        }
     }

   bool isAverage = false;
   for(int i = 1; i<= AVERAGE_COUNT; i++)
     {
      if(Average_Start[n][i] && Average_Finish[n][i])
        {
         isAverage = true;
         break;
        }
     }

   /*
   // if one of these filters enabled then create sets array
   if (
       (Level_Start_1>0 && Level_Finish_1>0) || (Level_Start_2>0 && Level_Finish_2>0) || (Level_Start_3>0 && Level_Finish_3>0) ||
       (Level_Start_4>0 && Level_Finish_4>0) || (Level_Start_5>0 && Level_Finish_5>0) || (Level_Start_6>0 && Level_Finish_6>0) ||

       (Momentum_Start_1>0 && Momentum_Finish_1>0) || (Momentum_Start_2>0 && Momentum_Finish_2>0) || (Momentum_Start_3>0 && Momentum_Finish_3>0) ||
       (Momentum_Start_4>0 && Momentum_Finish_4>0) || (Momentum_Start_5>0 && Momentum_Finish_5>0) || (Momentum_Start_6>0 && Momentum_Finish_6>0) ||

       (Price_Start_1>0 && Price_Finish_1>0) || (Price_Start_2>0 && Price_Finish_2>0) || (Price_Start_3>0 && Price_Finish_3>0) ||
       (Price_Start_4>0 && Price_Finish_4>0) || (Price_Start_5>0 && Price_Finish_5>0) || (Price_Start_6>0 && Price_Finish_6>0) ||

       (Average_Start_1>0 && Average_Finish_1>0) || (Average_Start_2>0 && Average_Finish_2>0) || (Average_Start_3>0 && Average_Finish_3>0) ||
       (Average_Start_4>0 && Average_Finish_4>0) || (Average_Start_5>0 && Average_Finish_5>0) || (Average_Start_6>0 && Average_Finish_6>0) ||
       (Average_Start_7>0 && Average_Finish_7>0) || (Average_Start_8>0 && Average_Finish_8>0) || (Average_Start_9>0 && Average_Finish_9>0) ||
       (Average_Start_10>0 && Average_Finish_10>0) || (Average_Start_11>0 && Average_Finish_11>0) || (Average_Start_12>0 && Average_Finish_12>0) ||
       (Average_Start_13>0 && Average_Finish_13>0) || (Average_Start_14>0 && Average_Finish_14>0) || (Average_Start_15>0 && Average_Finish_15>0)

       )
         Define_Sets(pair);
   */

// if one of these filters enabled then create sets array
   if(isLevel || isMomentum || isAverage || isPrice)
      Define_Sets(pair);

   int i, set, res, gbuy, gsell, buy, sell;
   double endclose=0, beginopen=0, gdif=0, dif=0, c=0, av=0;

// check for BUY
   if(cmd==0)
     {
      // for LEVEL
      if(isLevel)
        {
         // check cycle
         for(int j=1; j<=LEVEL_COUNT; j++)
           {
            gbuy=0;
            gsell=0;
            int Start = Level_Start[n][j];
            int Finish = Level_Finish[n][j];
            bool Reverse = Level_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               buy=0;
               sell=0;
               for(i=Start; i<=Finish; i++)
                 {
                  if(i==1)
                     endclose=iClose(pair, tf, 1);
                  else
                     endclose=iClose(pair, tf, Sets_Start[i-1]+1);
                  beginopen=iOpen(pair, tf, Sets_Start[i+1]);
                  res=Result(pair, endclose, beginopen, CheckBB(pair,Sets_Start[i-1]+1));
                  if(res>0.0)
                     buy++;
                  if(res<0.0)
                     sell++;
                  //Print("i = ", i, ", endclose # = ", Sets_Start[i-1]+1, ", beginopen # = ", Sets_Start[i+1]);
                 }
               // check result
               if(!Reverse)
                 {
                  gbuy=gbuy+buy;
                  gsell=gsell+sell;
                 }
               else
                 {
                  gbuy=gbuy+sell;
                  gsell=gsell+buy;
                 }
              }

            // LEVEL result
            if(gsell>gbuy)
               return(false);
           }
        }


      // for MOMENTUM
      if(isMomentum)
        {
         // check cycle
         for(int j=1; j<=MOMENTUM_COUNT; j++)
           {
            gbuy=0;
            gsell=0;
            int Start = Momentum_Start[n][j];
            int Finish = Momentum_Finish[n][j];
            bool Reverse = Momentum_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               set=0;
               buy=0;
               sell=0;

               for(i=Sets_Start[Finish]; i>=Sets_Start[Start-1]+1; i--)
                 {
                  if(CheckBB(pair,i)==0)
                     buy++;
                  if(CheckBB(pair,i)==1)
                     sell++;
                 }

               // check result
               if(!Reverse)
                 {
                  gbuy=gbuy+buy;
                  gsell=gsell+sell;
                 }
               else
                 {
                  gbuy=gbuy+sell;
                  gsell=gsell+buy;
                 }
              }

            // MOMENTUM result
            if(gsell>gbuy)
               return(false);
           }
        }


      // for PRICE
      if(isPrice)
        {
         // check cycle
         for(int j=1; j<=PRICE_COUNT; j++)
           {
            gdif=0;
            int Start = Price_Start[n][j];
            int Finish = Price_Finish[n][j];
            bool Reverse = Price_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               dif=0;
               // define values
               beginopen=iOpen(pair, tf, Sets_Start[Finish]);
               endclose=iClose(pair, tf, Sets_Start[Start-1]+1);
               dif=NormalizeDouble(endclose-beginopen, (int)MarketInfo(pair, MODE_DIGITS));

               // check result
               if(Reverse)
                  dif=(-1.0)*dif;
               gdif=gdif+dif;
              }

            // PRICE result
            if(gdif<0.0)
               return(false);
           }
        }


      // for AVERAGE
      if(isAverage)
        {
         // check cycle
         for(int j=1; j<=AVERAGE_COUNT; j++)
           {
            gbuy=0;
            gsell=0;
            int Start = Average_Start[n][j];
            int Finish = Average_Finish[n][j];
            bool Reverse = Average_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               buy=0;
               sell=0;
               c=0;
               av=0;
               for(i=Sets_Start[Finish]; i>=Sets_Start[Start-1]+1; i--)
                 {
                  c++;
                  av=av+iClose(pair, tf, i);
                 }
               av=NormalizeDouble(av/c, (int)MarketInfo(pair, MODE_DIGITS));
               if(av>iClose(pair, tf, Sets_Start[Start-1]+1))
                  buy++;
               else
                  if(av<iClose(pair, tf, Sets_Start[Start-1]+1))
                     sell++;
               //Print("av=", av, ", lastclose=", iClose(pair, 0, Sets_Start[Average_Start_1-1]+1));
               // check result
               if(!Reverse)
                 {
                  gbuy=gbuy+buy;
                  gsell=gsell+sell;
                 }
               else
                 {
                  gbuy=gbuy+sell;
                  gsell=gsell+buy;
                 }
              }

            // AVERAGE result
            if(gsell>gbuy)
               return(false);
           }
        }


     }



// check for SELL
   if(cmd==1)
     {
      // for LEVEL
      if(isLevel)
        {
         // check cycle
         for(int j=1; j<=LEVEL_COUNT; j++)
           {
            gbuy=0;
            gsell=0;
            int Start = Level_Start[n][j];
            int Finish = Level_Finish[n][j];
            bool Reverse = Level_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               buy=0;
               sell=0;
               for(i=Start; i<=Finish; i++)
                 {
                  if(i==1)
                     endclose=iClose(pair, tf, 1);
                  else
                     endclose=iClose(pair, tf, Sets_Start[i-1]+1);
                  beginopen=iOpen(pair, tf, Sets_Start[i+1]);
                  res=Result(pair, endclose, beginopen, CheckBB(pair,Sets_Start[i-1]+1));
                  if(res>0.0)
                     buy++;
                  if(res<0.0)
                     sell++;
                  //Print("i = ", i, ", endclose # = ", Sets_Start[i-1]+1, ", beginopen # = ", Sets_Start[i+1]);
                 }
               // check result
               if(!Reverse)
                 {
                  gbuy=gbuy+buy;
                  gsell=gsell+sell;
                 }
               else
                 {
                  gbuy=gbuy+sell;
                  gsell=gsell+buy;
                 }
              }

            // LEVEL result
            if(gbuy>gsell)
               return(false);
           }
        }


      // for MOMENTUM
      if(isMomentum)
        {
         // check cycle
         for(int j=1; j<=MOMENTUM_COUNT; j++)
           {
            gbuy=0;
            gsell=0;
            int Start = Momentum_Start[n][j];
            int Finish = Momentum_Finish[n][j];
            bool Reverse = Momentum_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               set=0;
               buy=0;
               sell=0;

               for(i=Sets_Start[Finish]; i>=Sets_Start[Start-1]+1; i--)
                 {
                  if(CheckBB(pair,i)==0)
                     buy++;
                  if(CheckBB(pair,i)==1)
                     sell++;
                 }

               // check result
               if(!Reverse)
                 {
                  gbuy=gbuy+buy;
                  gsell=gsell+sell;
                 }
               else
                 {
                  gbuy=gbuy+sell;
                  gsell=gsell+buy;
                 }
              }

            // MOMENTUM result
            if(gbuy>gsell)
               return(false);
           }
        }


      // for PRICE
      if(isPrice)
        {
         // check cycle
         for(int j=1; j<=PRICE_COUNT; j++)
           {
            gdif=0;
            int Start = Price_Start[n][j];
            int Finish = Price_Finish[n][j];
            bool Reverse = Price_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               dif=0;
               // define values
               beginopen=iOpen(pair, tf, Sets_Start[Finish]);
               endclose=iClose(pair, tf, Sets_Start[Start-1]+1);
               dif=NormalizeDouble(endclose-beginopen, (int)MarketInfo(pair, MODE_DIGITS));
               // check result
               if(Reverse)
                  dif=(-1.0)*dif;
               gdif=gdif+dif;
              }

            // PRICE result
            if(gdif>0)
               return(false);
           }
        }


      // for AVERAGE
      if(isAverage)
        {
         // check cycle
         for(int j=1; j<=AVERAGE_COUNT; j++)
           {
            gbuy=0;
            gsell=0;
            int Start = Average_Start[n][j];
            int Finish = Average_Finish[n][j];
            bool Reverse = Average_Reverse[n][j];

            if(Start<=0 || Finish<=0)
               continue;

            // for J
            if(Start>0 && Finish>0 && Start<=Finish)
              {
               buy=0;
               sell=0;
               c=0;
               av=0;
               for(i=Sets_Start[Finish]; i>=Sets_Start[Start-1]+1; i--)
                 {
                  c++;
                  av=av+iClose(pair, tf, i);
                 }
               av=NormalizeDouble(av/c, (int)MarketInfo(pair, MODE_DIGITS));
               if(av>iClose(pair, tf, Sets_Start[Start-1]+1))
                  buy++;
               else
                  if(av<iClose(pair, tf, Sets_Start[Start-1]+1))
                     sell++;
               //Print("av=", av, ", lastclose=", iClose(pair, 0, Sets_Start[Average_Start_1-1]+1));
               // check result
               if(!Reverse)
                 {
                  gbuy=gbuy+buy;
                  gsell=gsell+sell;
                 }
               else
                 {
                  gbuy=gbuy+sell;
                  gsell=gsell+buy;
                 }
              }

            // AVERAGE result
            if(gbuy>gsell)
               return(false);
           }
        }

     }

   return(true);
  }

//+------------------------------------------------------------------+
//| Define sets                                                      |
//+------------------------------------------------------------------+
void Define_Sets(string pair)
  {
   int c=0;
   ArrayInitialize(Sets_Start, 0);
// define +1 and -1
   for(int i=1; i<iBars(pair,tf); i++)
     {
      // check MAX
      if(c==100)
         break;
      // define starts of sets
      if(CheckBB(pair,i)!=CheckBB(pair,i+1))
        {
         c++;
         Sets_Start[c]=i;
        }
     }

   return;
  }

/*
//+------------------------------------------------------------------+
//| Measure values                                                   |
//+------------------------------------------------------------------+
void Define_Values(int counted)
   {
    // define +1 and -1
    for (int i=1; i<=counted; i++)
      {
       //if (CheckBB(i)!=CheckBB(i+1)) RES[i-1]=Result(i, CheckBB(i));
       //RES[i-1]=Result(i, CheckBB(i));
      }

    return;
   }
*/

//+------------------------------------------------------------------+
//| Define +1 and -1                                                 |
//+------------------------------------------------------------------+
int Result(string pair, double cl, double op, int cmd)
  {
// check result
   if(cmd==0 && NormalizeDouble(cl, (int)MarketInfo(pair, MODE_DIGITS))>NormalizeDouble(op, (int)MarketInfo(pair, MODE_DIGITS)))
      return(1);
   else
      if(cmd==0 && NormalizeDouble(cl, (int)MarketInfo(pair, MODE_DIGITS))<=NormalizeDouble(op, (int)MarketInfo(pair, MODE_DIGITS)))
         return(-1);
      else
         if(cmd==1 && NormalizeDouble(cl, (int)MarketInfo(pair, MODE_DIGITS))<NormalizeDouble(op, (int)MarketInfo(pair, MODE_DIGITS)))
            return(-1);
         else
            if(cmd==1 && NormalizeDouble(cl, (int)MarketInfo(pair, MODE_DIGITS))>=NormalizeDouble(op, (int)MarketInfo(pair, MODE_DIGITS)))
               return(1);
            else
               if(cmd==-1 && NormalizeDouble(cl, (int)MarketInfo(pair, MODE_DIGITS))>NormalizeDouble(op, (int)MarketInfo(pair, MODE_DIGITS)))
                  return(1);
               else
                  if(cmd==-1 && NormalizeDouble(cl, (int)MarketInfo(pair, MODE_DIGITS))<NormalizeDouble(op, (int)MarketInfo(pair, MODE_DIGITS)))
                     return(-1);
                  else
                     if(cmd==-1 && NormalizeDouble(cl, (int)MarketInfo(pair, MODE_DIGITS))==NormalizeDouble(op, (int)MarketInfo(pair, MODE_DIGITS)))
                        return(-1);
                     else
                        return(0); //{ Print("x=", x, ", ELSE"); return(0); }
  }

//+------------------------------------------------------------------+
//| Check bullish or bearish                                         |
//+------------------------------------------------------------------+
int CheckBB(string pair, int x)
  {
// BULL
   if(NormalizeDouble(iClose(pair, tf, x), (int)MarketInfo(pair, MODE_DIGITS))>NormalizeDouble(iOpen(pair, tf, x), (int)MarketInfo(pair, MODE_DIGITS)))
      return(0);
// BEAR
   else
      if(NormalizeDouble(iClose(pair, tf, x), (int)MarketInfo(pair, MODE_DIGITS))<NormalizeDouble(iOpen(pair, tf, x), (int)MarketInfo(pair, MODE_DIGITS)))
         return(1);
      // another case
      else
         return(-1);
  }

//+------------------------------------------------------------------+
//| Count of open orders                                             |
//+------------------------------------------------------------------+
int OrderCount(string pair, int type, bool rev=false)
  {
   int total = OrdersTotal();
   int oc=0;

   for(int cnt=total-1; cnt>=0; cnt--)
     {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
         continue;
      if(OrderSymbol()!=pair)
         continue;
      if(OrderMagicNumber()!=MagicNumber && !rev)
         continue;
      if(OrderMagicNumber()!=MagicNumber2 && rev)
         continue;
      //if (OrderOpenTime()<Start_Time) continue;
      if(OrderType() == type || type == -1)
        {
         //t=OrderOpenTime();
         if(type==OP_BUY)
            TBUY=OrderOpenTime();
         if(type==OP_SELL)
            TSELL=OrderOpenTime();
         oc+=1;
        }
     }

   return(oc);
  }

//+------------------------------------------------------------------+
//| Count of open orders                                             |
//+------------------------------------------------------------------+
int OrderCountExtr(string pair, int type)
  {
   int total = OrdersTotal();
   int oc=0;

   for(int cnt=total-1; cnt>=0; cnt--)
     {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
         continue;
      if(OrderSymbol()!=pair)
         continue;
      if(OrderMagicNumber()!=MagicNumber3)
         continue;
      //if (OrderOpenTime()<Start_Time) continue;
      if(OrderType() == type || type == -1)
         oc+=1;
     }

   return(oc);
  }


//+------------------------------------------------------------------+
//| Check last order CMD                                             |
//+------------------------------------------------------------------+
int CheckLastCMD(string pair)
  {
   int total = OrdersHistoryTotal();
   int cmd=-1;

// define PROFIT of last order
   for(int cnt=total-1; cnt>=0; cnt--)
     {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY))
         continue;
      if(OrderSymbol()!=pair)
         continue;
      // usual order
      if(OrderMagicNumber()==MagicNumber)
        {
         cmd=OrderType();
         break;
        }
      // reverse order
      if(OrderMagicNumber()==MagicNumber2)
        {
         if(OrderType()==OP_BUY)
            cmd=OP_SELL;
         else
            if(OrderType()==OP_SELL)
               cmd=OP_BUY;

         break;
        }
     }

   return(cmd);
  }


//+------------------------------------------------------------------+
//| Close orders by CMD                                              |
//+------------------------------------------------------------------+
void CloseOrd(string pair, int cmd, bool rev=false)
  {
   int tkt;
   int k;

   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderMagicNumber()!=MagicNumber && !rev)
         continue;
      if(OrderMagicNumber()!=MagicNumber2 && rev)
         continue;
      if(OrderSymbol()!=pair)
         continue;

      tkt=OrderTicket();

      if(cmd==0 && OrderType()==OP_BUY)
        {
         RefreshRates();
         for(k=1; k<=5; k++)
           {
            if(!OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(MarketInfo(pair, MODE_BID), (int)MarketInfo(pair, MODE_DIGITS)), Slippage, clrGreen))
              {
               Sleep(1000);
               RefreshRates();
               continue;
              }

            break;
           }
        }

      if(cmd==1 && OrderType()==OP_SELL)
        {
         RefreshRates();
         for(k=1; k<=5; k++)
           {
            if(!OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(MarketInfo(pair, MODE_ASK), (int)MarketInfo(pair, MODE_DIGITS)), Slippage, clrRed))
              {
               Sleep(1000);
               RefreshRates();
               continue;
              }

            break;
           }
        }

      if(cmd>=2 && OrderType()==cmd)
        {
         RefreshRates();
         for(k=1; k<=5; k++)
           {
            if(!OrderDelete(OrderTicket(), clrNONE))
              {
               Sleep(1000);
               RefreshRates();
               continue;
              }
            break;
           }
        }

     }

   return;
  }

//+------------------------------------------------------------------+
//| Close orders by CMD                                              |
//+------------------------------------------------------------------+
void CloseOrdExtr(string pair, int cmd)
  {
   int tkt;
   int k;

   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderMagicNumber()!=MagicNumber3)
         continue;
      if(OrderSymbol()!=pair)
         continue;

      tkt=OrderTicket();

      if(cmd==0 && OrderType()==OP_BUY)
        {
         RefreshRates();
         for(k=1; k<=5; k++)
           {
            if(!OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(MarketInfo(pair, MODE_BID), (int)MarketInfo(pair, MODE_DIGITS)), Slippage, clrGreen))
              {
               Sleep(1000);
               RefreshRates();
               continue;
              }

            break;
           }
        }

      if(cmd==1 && OrderType()==OP_SELL)
        {
         RefreshRates();
         for(k=1; k<=5; k++)
           {
            if(!OrderClose(OrderTicket(), OrderLots(), NormalizeDouble(MarketInfo(pair, MODE_ASK), (int)MarketInfo(pair, MODE_DIGITS)), Slippage, clrRed))
              {
               Sleep(1000);
               RefreshRates();
               continue;
              }

            break;
           }
        }

      if(cmd>=2 && OrderType()==cmd)
        {
         RefreshRates();
         for(k=1; k<=5; k++)
           {
            if(!OrderDelete(OrderTicket(), clrNONE))
              {
               Sleep(1000);
               RefreshRates();
               continue;
              }
            break;
           }
        }

     }

   return;
  }

//+------------------------------------------------------------------+
//| Open orders                                                      |
//+------------------------------------------------------------------+
void OpenOrd(string pair, int cmd, int n)
  {
// in test mode trade ONLY current symbol
   if(IsTesting() && pair!=Symbol())
      return;

   if(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD)>GetMaxValue(Mins,ArraySize(Mins)) && GetMaxValue(Mins,ArraySize(Mins))!=0 && Spread_Filter)
     {
      // Print("Spread Higher" +SymbolInfoInteger(_Symbol,SYMBOL_SPREAD) +"----"+GetMaxValue(Mins,ArraySize(Mins)));
      return;
     }

// check STRATEGY and CMD
   if((n==1 && cmd==OP_SELL) || (n==2 && cmd==OP_BUY))
      return;

// check ON strategy or NOT
   if(Type_Ar[n]==0)
      return;

      // define Inds value
      double inds_val=Check_Indicators(0, cmd);
      // check and return if wrong !!!
      if(!inds_val)
         return;
    

// check LAST order
   int last=CheckLastCMD(pair);
   if(cmd==last)
      return;

   double Stop=0, Take=0;
   int tkt=-1;

   double Lots=Lots_Ar[n];
   double TakeProfit=TakeProfit_Ar[n];
   double StopLoss=StopLoss_Ar[n];

// define lot value
   double S=MarketInfo(pair, MODE_BID)*StopLoss/100.0;
   double T=MarketInfo(pair, MODE_BID)*TakeProfit/100.0;
   if(StopLoss==0)
      S=0;
   if(TakeProfit==0)
      T=0;

   bool rev=false;
   double Lot=0;

   int mn=MagicNumber;
   string add="";

   Lot=Lots_Optimized(pair,Lots,cmd,rev);

//rev_for_extra=rev;

// check for REVERSE
   if(rev)
     {
      mn=MagicNumber2;
      add=" REV";
      cmd=!cmd;
     }


   /*
   // check for DEC lot size
   if (Lot==-1.0)
     {
      Print("Lot was decreased on 100%! Trade will be skipped!");
      return;
     }
   */

   for(int i=1; i<=10; i++)
     {
      if(cmd==OP_BUY)
         tkt=OrderSend(pair, cmd, Lot, NormalizeDouble(MarketInfo(pair, MODE_ASK), (int)MarketInfo(pair, MODE_DIGITS)), Slippage, 0, 0, com+add, mn, 0, clrGreen);
      if(cmd==OP_SELL)
         tkt=OrderSend(pair, cmd, Lot, NormalizeDouble(MarketInfo(pair, MODE_BID), (int)MarketInfo(pair, MODE_DIGITS)), Slippage, 0, 0, com+add, mn, 0, clrRed);

      // if order was opened
      if(tkt>0)
        {
         if(!OrderSelect(tkt, SELECT_BY_TICKET))
            return;
         double price=NormalizeDouble(OrderOpenPrice(), (int)MarketInfo(pair, MODE_DIGITS));

         // define SL
         if(cmd==0)
           {
            Stop=NormalizeDouble(price-S, (int)MarketInfo(pair, MODE_DIGITS));
            Take=NormalizeDouble(price+T, (int)MarketInfo(pair, MODE_DIGITS));
           }
         if(cmd==1)
           {
            Stop=NormalizeDouble(price+S, (int)MarketInfo(pair, MODE_DIGITS));
            Take=NormalizeDouble(price-T, (int)MarketInfo(pair, MODE_DIGITS));
           }

         if(S==0)
            Stop=0;
         if(T==0)
            Take=0;

         // check for '0'
         //if (TakeProfit==0) Take=0;
         //if (StopLoss==0) Stop=0;

         // if Spread_Filter = TRUE
         if(Spread_Filter)
           {
            // define SL
            if(cmd==0)
              {
               GlobalVariableSet(GV_Buy_SL, NormalizeDouble(Stop, (int)MarketInfo(pair, MODE_DIGITS)));
               GlobalVariableSet(GV_Buy_TP, NormalizeDouble(Take, (int)MarketInfo(pair, MODE_DIGITS)));
              }
            if(cmd==1)
              {
               GlobalVariableSet(GV_Sell_SL, NormalizeDouble(Stop, (int)MarketInfo(pair, MODE_DIGITS)));
               GlobalVariableSet(GV_Sell_TP, NormalizeDouble(Take, (int)MarketInfo(pair, MODE_DIGITS)));
              }
           }
         // Modify order
         else
            if(!Spread_Filter && (Stop>0 || Take>0))
              {
               for(int k=1; k<=20; k++)
                 {
                  if(!OrderModify(tkt, OrderOpenPrice(), NormalizeDouble(Stop, (int)MarketInfo(pair, MODE_DIGITS)), NormalizeDouble(Take, (int)MarketInfo(pair, MODE_DIGITS)), 0, CLR_NONE))
                    {
                     Sleep(1000);
                     RefreshRates();
                     continue;
                    }
                  break;
                 }
              }

         // all is good, main order opened, so it's time to open EXTRA orders

         break;
        }
      else
        {
         Sleep(1000);
         RefreshRates();
         continue;
        }
     }

   return;
  }

//+------------------------------------------------------------------+
//| Measure lot size                                                 |
//+------------------------------------------------------------------+
double Lots_Optimized(string pair, double Risk, int cmd, bool &rev)
  {
   double Lot=0;
   double lot_step=MarketInfo(pair, MODE_LOTSTEP);
   int dig=2;

   if(lot_step==0.01)
      dig=2;
   if(lot_step==0.1)
      dig=1;
   if(lot_step==1)
      dig=0;

//double slv=(MathAbs(s*Poin) / MarketInfo(SYM, MODE_TICKSIZE) * MarketInfo(SYM, MODE_TICKVALUE))*100.0;
   if(Risk>0.0)
     {
      double Long_Lot=MarketInfo(pair, MODE_MARGINREQUIRED); // cost of 1 lot
      //Print("Long_Lot=", Long_Lot, ", lot_step=", lot_step, ", pair=", pair);
      if(Long_Lot!=0.0 && lot_step!=0.0)
         Lot=MathFloor(AccountEquity()*Risk/100.0/Long_Lot/lot_step)*lot_step;
      Lot=NormalizeDouble(Lot, dig);
     }
   else
      Lot=MarketInfo(pair, MODE_MINLOT);

   /*
   GV_Buy_Win=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Buy_Win";
   GV_Buy_Loss=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Buy_Loss";
   GV_Sell_Win=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Sell_Win";
   GV_Sell_Loss=com+"_"+IntegerToString(IsTesting())+"_"+Pair_Name+"_"+IntegerToString(tf)+"_"+IntegerToString(MagicNumber)+"_Sell_Loss";
   */

   count_for_extra=0;
   Lot_for_extra=0;
//rev_for_extra=false;

   int count=0;
   bool increase=false, decrease=false, reverse=false;

// check Win/Loss increase
   if(GlobalVariableGet(GV_Win)>0)
     {
      count=OrderCountFromTime(pair, -1, (datetime)GlobalVariableGet(GV_Win));

      if(count>=WinIncrease && WinIncrease==12)
         GlobalVariableDel(GV_Win);

      // check for NORMAL
      if(count<=11 && Win_Increase[count+1]==0)
        {
         increase=false;
         decrease=false;
         reverse=false;
         Print("Set NORMAL lot!");
        }
      // check for INC
      if(count<=11 && Win_Increase[count+1]==1)
        {
         increase=true;
         decrease=false;
         reverse=false;
        }
      // check for DEC
      if(count<=11 && Win_Increase[count+1]==-1)
        {
         increase=false;
         decrease=true;
         reverse=false;
        }
      // check for REV
      if(count<=11 && Win_Increase[count+1]==2)
        {
         increase=false;
         decrease=false;
         reverse=true;
        }
     }

   if(GlobalVariableGet(GV_Loss)>0 && !increase)
     {
      count=OrderCountFromTime(pair, -1, (datetime)GlobalVariableGet(GV_Loss));

      if(count>=LossIncrease && LossIncrease==12)
         GlobalVariableDel(GV_Loss);

      // check for NORMAL
      if(count<=11 && Loss_Increase[count+1]==0)
        {
         increase=false;
         decrease=false;
         reverse=false;
         Print("Set NORMAL lot!");
        }
      // check for INC
      if(count<=11 && Loss_Increase[count+1]==1)
        {
         increase=true;
         decrease=false;
         reverse=false;
        }
      // check for DEC
      if(count<=11 && Loss_Increase[count+1]==-1)
        {
         increase=false;
         decrease=true;
         reverse=false;
        }
      // check for REV
      if(count<=11 && Loss_Increase[count+1]==2)
        {
         increase=false;
         decrease=false;
         reverse=true;
        }
     }



// check "increase" variable

//if (!increase && !decrease && !reverse) {  }

   if(increase && !decrease && !reverse)
     {
      Lot=NormalizeDouble(Lot*1.5, dig);
      Print("Need Increase!!!");
     }
   if(!increase && decrease && !reverse)
     {
      Lot=NormalizeDouble(Lot*0.01, dig);
      Print("Need Decrease!!!");
     }
   if(!increase && !decrease && reverse)
     {
      Lot=NormalizeDouble(Lot*1.5, dig);
      rev=true;
      Print("Need Reverse!!!");
     }


//Print("L=", DoubleToStr(Lot, 5));

   if(Lot<MarketInfo(pair, MODE_MINLOT))
      Lot=MarketInfo(pair, MODE_MINLOT);
   if(Lot>MarketInfo(pair, MODE_MAXLOT))
      Lot=MarketInfo(pair, MODE_MAXLOT);

   count_for_extra=count;
   Lot_for_extra=NormalizeDouble(Lot, dig);
//rev_for_extra=rev;

   return (NormalizeDouble(Lot, dig));
  }




//+------------------------------------------------------------------+
//| Check Profit                                                     |
//+------------------------------------------------------------------+
int OrderCountFromTime(string pair, int type, datetime t)
  {
   int total = OrdersHistoryTotal();
   int oc=0;

   for(int cnt=0; cnt<total; cnt++)
     {
      if(!OrderSelect(cnt, SELECT_BY_POS, MODE_HISTORY))
         continue;
      if(OrderSymbol()!=pair && pair!="")
         continue;
      if(OrderMagicNumber()!=MagicNumber && OrderMagicNumber()!=MagicNumber2)
         continue;
      //if (OrderOpenTime()<Start_Time) continue;
      if(OrderOpenTime()<t)
         continue;
      if(OrderType() == type || type == -1)
         oc++;
     }

   return(oc);
  }

//+------------------------------------------------------------------+
//| Define new candle                                                |
//+------------------------------------------------------------------+
bool New_Candle()
  {
   if(New_Time!=iTime(NULL, tf, 0))
     {
      New_Time=iTime(NULL, tf, 0);
      return(true);
     }
   else
      return(false);
  }

//+------------------------------------------------------------------+
//| Set arrays                                                       |
//+------------------------------------------------------------------+
void SetArrays()
  {
//double Poin;

// for Strategy 1
   Level_Start[1][1]=Long_Level_Start_One;
   Level_Finish[1][1]=Long_Level_Finish_One;
   Level_Reverse[1][1]=Long_Level_Reverse_One;
   Level_Start[1][2]=Long_Level_Start_Two;
   Level_Finish[1][2]=Long_Level_Finish_Two;
   Level_Reverse[1][2]=Long_Level_Reverse_Two;
   Level_Start[1][3]=Long_Level_Start_Three;
   Level_Finish[1][3]=Long_Level_Finish_Three;
   Level_Reverse[1][3]=Long_Level_Reverse_Three;
   Level_Start[1][4]=Long_Level_Start_Four;
   Level_Finish[1][4]=Long_Level_Finish_Four;
   Level_Reverse[1][4]=Long_Level_Reverse_Four;
   Level_Start[1][5]=Long_Level_Start_Five;
   Level_Finish[1][5]=Long_Level_Finish_Five;
   Level_Reverse[1][5]=Long_Level_Reverse_Five;


   Momentum_Start[1][1]=Long_Momentum_Start_One;
   Momentum_Finish[1][1]=Long_Momentum_Finish_One;
   Momentum_Reverse[1][1]=Long_Momentum_Reverse_One;
   Momentum_Start[1][2]=Long_Momentum_Start_Two;
   Momentum_Finish[1][2]=Long_Momentum_Finish_Two;
   Momentum_Reverse[1][2]=Long_Momentum_Reverse_Two;
   Momentum_Start[1][3]=Long_Momentum_Start_Three;
   Momentum_Finish[1][3]=Long_Momentum_Finish_Three;
   Momentum_Reverse[1][3]=Long_Momentum_Reverse_Three;
   Momentum_Start[1][4]=Long_Momentum_Start_Four;
   Momentum_Finish[1][4]=Long_Momentum_Finish_Four;
   Momentum_Reverse[1][4]=Long_Momentum_Reverse_Four;
   Momentum_Start[1][5]=Long_Momentum_Start_Five;
   Momentum_Finish[1][5]=Long_Momentum_Finish_Five;
   Momentum_Reverse[1][5]=Long_Momentum_Reverse_Five;


   Price_Start[1][1]=Long_Price_Start_One;
   Price_Finish[1][1]=Long_Price_Finish_One;
   Price_Reverse[1][1]=Long_Price_Reverse_One;
   Price_Start[1][2]=Long_Price_Start_Two;
   Price_Finish[1][2]=Long_Price_Finish_Two;
   Price_Reverse[1][2]=Long_Price_Reverse_Two;
   Price_Start[1][3]=Long_Price_Start_Three;
   Price_Finish[1][3]=Long_Price_Finish_Three;
   Price_Reverse[1][3]=Long_Price_Reverse_Three;
   Price_Start[1][4]=Long_Price_Start_Four;
   Price_Finish[1][4]=Long_Price_Finish_Four;
   Price_Reverse[1][4]=Long_Price_Reverse_Four;
   Price_Start[1][5]=Long_Price_Start_Five;
   Price_Finish[1][5]=Long_Price_Finish_Five;
   Price_Reverse[1][5]=Long_Price_Reverse_Five;


   Average_Start[1][1]=Long_Average_Start_One;
   Average_Finish[1][1]=Long_Average_Finish_One;
   Average_Reverse[1][1]=Long_Average_Reverse_One;
   Average_Start[1][2]=Long_Average_Start_Two;
   Average_Finish[1][2]=Long_Average_Finish_Two;
   Average_Reverse[1][2]=Long_Average_Reverse_Two;
   Average_Start[1][3]=Long_Average_Start_Three;
   Average_Finish[1][3]=Long_Average_Finish_Three;
   Average_Reverse[1][3]=Long_Average_Reverse_Three;
   Average_Start[1][4]=Long_Average_Start_Four;
   Average_Finish[1][4]=Long_Average_Finish_Four;
   Average_Reverse[1][4]=Long_Average_Reverse_Four;
   Average_Start[1][5]=Long_Average_Start_Five;
   Average_Finish[1][5]=Long_Average_Finish_Five;
   Average_Reverse[1][5]=Long_Average_Reverse_Five;
   Average_Start[1][6]=Long_Average_Start_Six;
   Average_Finish[1][6]=Long_Average_Finish_Six;
   Average_Reverse[1][6]=Long_Average_Reverse_Six;
   Average_Start[1][7]=Long_Average_Start_Seven;
   Average_Finish[1][7]=Long_Average_Finish_Seven;
   Average_Reverse[1][7]=Long_Average_Reverse_Seven;
   Average_Start[1][8]=Long_Average_Start_Eight;
   Average_Finish[1][8]=Long_Average_Finish_Eight;
   Average_Reverse[1][8]=Long_Average_Reverse_Eight;
   Average_Start[1][9]=Long_Average_Start_Nine;
   Average_Finish[1][9]=Long_Average_Finish_Nine;
   Average_Reverse[1][9]=Long_Average_Reverse_Nine;




   Type_Ar[1]=Long_Type;

   Pair_Ar[1]=Pair_Name;
   Lots_Ar[1]=Long_Lots;
   TakeProfit_Ar[1]=Long_TakeProfit;
   StopLoss_Ar[1]=Long_StopLoss;

//Check number of digits
   double point=MarketInfo(Pair_Ar[1], MODE_POINT);
   if(point == 0.00001)
      Poin[1] = 0.0001; //5 dig
   else
      if(point == 0.001)
         Poin[1] = 0.01; //3 dig
      else
         Poin[1] = point; //4 dig


// for Strategy 2
   Level_Start[2][1]=Short_Level_Start_One;
   Level_Finish[2][1]=Short_Level_Finish_One;
   Level_Reverse[2][1]=Short_Level_Reverse_One;
   Level_Start[2][2]=Short_Level_Start_Two;
   Level_Finish[2][2]=Short_Level_Finish_Two;
   Level_Reverse[2][2]=Short_Level_Reverse_Two;
   Level_Start[2][3]=Short_Level_Start_Three;
   Level_Finish[2][3]=Short_Level_Finish_Three;
   Level_Reverse[2][3]=Short_Level_Reverse_Three;
   Level_Start[2][4]=Short_Level_Start_Four;
   Level_Finish[2][4]=Short_Level_Finish_Four;
   Level_Reverse[2][4]=Short_Level_Reverse_Four;
   Level_Start[2][5]=Short_Level_Start_Five;
   Level_Finish[2][5]=Short_Level_Finish_Five;
   Level_Reverse[2][5]=Short_Level_Reverse_Five;


   Momentum_Start[2][1]=Short_Momentum_Start_One;
   Momentum_Finish[2][1]=Short_Momentum_Finish_One;
   Momentum_Reverse[2][1]=Short_Momentum_Reverse_One;
   Momentum_Start[2][2]=Short_Momentum_Start_Two;
   Momentum_Finish[2][2]=Short_Momentum_Finish_Two;
   Momentum_Reverse[2][2]=Short_Momentum_Reverse_Two;
   Momentum_Start[2][3]=Short_Momentum_Start_Three;
   Momentum_Finish[2][3]=Short_Momentum_Finish_Three;
   Momentum_Reverse[2][3]=Short_Momentum_Reverse_Three;
   Momentum_Start[2][4]=Short_Momentum_Start_Four;
   Momentum_Finish[2][4]=Short_Momentum_Finish_Four;
   Momentum_Reverse[2][4]=Short_Momentum_Reverse_Four;
   Momentum_Start[2][5]=Short_Momentum_Start_Five;
   Momentum_Finish[2][5]=Short_Momentum_Finish_Five;
   Momentum_Reverse[2][5]=Short_Momentum_Reverse_Five;

   Price_Start[2][1]=Short_Price_Start_One;
   Price_Finish[2][1]=Short_Price_Finish_One;
   Price_Reverse[2][1]=Short_Price_Reverse_One;
   Price_Start[2][2]=Short_Price_Start_Two;
   Price_Finish[2][2]=Short_Price_Finish_Two;
   Price_Reverse[2][2]=Short_Price_Reverse_Two;
   Price_Start[2][3]=Short_Price_Start_Three;
   Price_Finish[2][3]=Short_Price_Finish_Three;
   Price_Reverse[2][3]=Short_Price_Reverse_Three;
   Price_Start[2][4]=Short_Price_Start_Four;
   Price_Finish[2][4]=Short_Price_Finish_Four;
   Price_Reverse[2][4]=Short_Price_Reverse_Four;
   Price_Start[2][5]=Short_Price_Start_Five;
   Price_Finish[2][5]=Short_Price_Finish_Five;
   Price_Reverse[2][5]=Short_Price_Reverse_Five;



   Average_Start[2][1]=Short_Average_Start_One;
   Average_Finish[2][1]=Short_Average_Finish_One;
   Average_Reverse[2][1]=Short_Average_Reverse_One;
   Average_Start[2][2]=Short_Average_Start_Two;
   Average_Finish[2][2]=Short_Average_Finish_Two;
   Average_Reverse[2][2]=Short_Average_Reverse_Two;
   Average_Start[2][3]=Short_Average_Start_Three;
   Average_Finish[2][3]=Short_Average_Finish_Three;
   Average_Reverse[2][3]=Short_Average_Reverse_Three;
   Average_Start[2][4]=Short_Average_Start_Four;
   Average_Finish[2][4]=Short_Average_Finish_Four;
   Average_Reverse[2][4]=Short_Average_Reverse_Four;
   Average_Start[2][5]=Short_Average_Start_Five;
   Average_Finish[2][5]=Short_Average_Finish_Five;
   Average_Reverse[2][5]=Short_Average_Reverse_Five;
   Average_Start[2][6]=Short_Average_Start_Six;
   Average_Finish[2][6]=Short_Average_Finish_Six;
   Average_Reverse[2][6]=Short_Average_Reverse_Six;
   Average_Start[2][7]=Short_Average_Start_Seven;
   Average_Finish[2][7]=Short_Average_Finish_Seven;
   Average_Reverse[2][7]=Short_Average_Reverse_Seven;
   Average_Start[2][8]=Short_Average_Start_Eight;
   Average_Finish[2][8]=Short_Average_Finish_Eight;
   Average_Reverse[2][8]=Short_Average_Reverse_Eight;
   Average_Start[2][9]=Short_Average_Start_Nine;
   Average_Finish[2][9]=Short_Average_Finish_Nine;
   Average_Reverse[2][9]=Short_Average_Reverse_Nine;


   Type_Ar[2]=Short_Type;
//Pair_Ar[2]=Short_Pair;
//Win_Increase[2][0]=Short_WinIncrease;
//Loss_Increase[2][0]=Short_LossIncrease;

   Pair_Ar[2]=Pair_Name;
   Lots_Ar[2]=Short_Lots;
   TakeProfit_Ar[2]=Short_TakeProfit;
   StopLoss_Ar[2]=Short_StopLoss;

// set Minutes array
   Mins[0]=Minutes_2;
   Mins[1]=Minutes_4;
   Mins[2]=Minutes_6;
   Mins[3]=Minutes_8;
   Mins[4]=Minutes_10;
   Mins[5]=Minutes_12;

//Check number of digits
   point=MarketInfo(Pair_Ar[2], MODE_POINT);
   if(point == 0.00001)
      Poin[2] = 0.0001; //5 dig
   else
      if(point == 0.001)
         Poin[2] = 0.01; //3 dig
      else
         Poin[2] = point; //4 dig



   Win_Increase[1]=(int)W1;
   Win_Increase[2]=(int)W2;
   Win_Increase[3]=(int)W3;
   Win_Increase[4]=(int)W4;
   Win_Increase[5]=(int)W5;
   Win_Increase[6]=(int)W6;
   Win_Increase[7]=(int)W7;
   Win_Increase[8]=(int)W8;
   Win_Increase[9]=(int)W9;
   Win_Increase[10]=(int)W10;


   /*
   // define WinIncrease
   for (int i=1; i<=12; i++)
     {
      if (Win_Increase[i]>=0) WinIncrease=i;
      else break;
     }
   */

   Loss_Increase[1]=(int)L1;
   Loss_Increase[2]=(int)L2;
   Loss_Increase[3]=(int)L3;
   Loss_Increase[4]=(int)L4;
   Loss_Increase[5]=(int)L5;
   Loss_Increase[6]=(int)L6;
   Loss_Increase[7]=(int)L7;
   Loss_Increase[8]=(int)L8;
   Loss_Increase[9]=(int)L9;
   Loss_Increase[10]=(int)L10;


   /*
   // define LossIncrease
   for (int i=1; i<=12; i++)
     {
      if (Loss_Increase[i]>=0) LossIncrease=i;
      else break;
     }
   */

   return;
  }


//+------------------------------------------------------------------+
//| Check Indicators                                                 |
//+------------------------------------------------------------------+
bool Check_Indicators(int w, int cmd)
  {
// check INDICATORS
//if (Check_STC(1, w, cmd) && Check_STC(2, w, cmd) && Check_STC(3, w, cmd))
//  return(true);
//else
//  return(false);

   for(int i=1; i<=STC_COUNT; i++)
     {
      if(!Check_STC(i, w, cmd))
         return(false);
     }

   return(true);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void defineSTCParameters(int indN, int cmd, int &CROSS, int &METHOD,
                         int &APPLY, double &DIVISOR, int &SHORT,
                         int &LONG, int &CYCLE, double &LEVEL)
  {
// for ind settings 1
   if(indN == 1)
     {

      if(cmd==0)
         CROSS=STCB_TRIGGER_One;
      else
         if(cmd==1)
            CROSS=STCS_TRIGGER_One;
      // define variables for CMD
      if(cmd==0)
         METHOD=STCB_METHOD_One;
      else
         if(cmd==1)
            METHOD=STCS_METHOD_One;

      if(cmd==0)
         APPLY=STCB_APPLY_One;
      else
         if(cmd==1)
            APPLY=STCS_APPLY_One;

      if(cmd==0)
         DIVISOR=STCB_DIVISOR_One;
      else
         if(cmd==1)
            DIVISOR=STCS_DIVISOR_One;

      if(cmd==0)
         SHORT=STCB_SHORT_One;
      else
         if(cmd==1)
            SHORT=STCS_SHORT_One;

      if(cmd==0)
         LONG=STCB_LONG_One;
      else
         if(cmd==1)
            LONG=STCS_LONG_One;

      if(cmd==0)
         CYCLE=STCB_CYCLE_One;
      else
         if(cmd==1)
            CYCLE=STCS_CYCLE_One;

      if(cmd==0)
         LEVEL=STCB_LEVEL_One;
      else
         if(cmd==1)
            LEVEL=STCS_LEVEL_One;
     }

// for ind settings 2
   else
      if(indN == 2)
        {
         if(cmd==0)
            CROSS=STCB_TRIGGER_Two;
         else
            if(cmd==1)
               CROSS=STCS_TRIGGER_Two;

         // define variables for CMD
         if(cmd==0)
            METHOD=STCB_METHOD_Two;
         else
            if(cmd==1)
               METHOD=STCS_METHOD_Two;

         if(cmd==0)
            APPLY=STCB_APPLY_Two;
         else
            if(cmd==1)
               APPLY=STCS_APPLY_Two;

         if(cmd==0)
            DIVISOR=STCB_DIVISOR_Two;
         else
            if(cmd==1)
               DIVISOR=STCS_DIVISOR_Two;

         if(cmd==0)
            SHORT=STCB_SHORT_Two;
         else
            if(cmd==1)
               SHORT=STCS_SHORT_Two;

         if(cmd==0)
            LONG=STCB_LONG_Two;
         else
            if(cmd==1)
               LONG=STCS_LONG_Two;

         if(cmd==0)
            CYCLE=STCB_CYCLE_Two;
         else
            if(cmd==1)
               CYCLE=STCS_CYCLE_Two;

         if(cmd==0)
            LEVEL=STCB_LEVEL_Two;
         else
            if(cmd==1)
               LEVEL=STCS_LEVEL_Two;
        }

      // for ind settings 3
      else
         if(indN == 3)
           {
            if(cmd==0)
               CROSS=STCB_TRIGGER_Three;
            else
               if(cmd==1)
                  CROSS=STCS_TRIGGER_Three;

            // define variables for CMD
            if(cmd==0)
               METHOD=STCB_METHOD_Three;
            else
               if(cmd==1)
                  METHOD=STCS_METHOD_Three;

            if(cmd==0)
               APPLY=STCB_APPLY_Three;
            else
               if(cmd==1)
                  APPLY=STCS_APPLY_Three;

            if(cmd==0)
               DIVISOR=STCB_DIVISOR_Three;
            else
               if(cmd==1)
                  DIVISOR=STCS_DIVISOR_Three;

            if(cmd==0)
               SHORT=STCB_SHORT_Three;
            else
               if(cmd==1)
                  SHORT=STCS_SHORT_Three;

            if(cmd==0)
               LONG=STCB_LONG_Three;
            else
               if(cmd==1)
                  LONG=STCS_LONG_Three;

            if(cmd==0)
               CYCLE=STCB_CYCLE_Three;
            else
               if(cmd==1)
                  CYCLE=STCS_CYCLE_Three;

            if(cmd==0)
               LEVEL=STCB_LEVEL_Three;
            else
               if(cmd==1)
                  LEVEL=STCS_LEVEL_Three;
           }

         // for ind settings 4
         else
            if(indN == 4)
              {
               if(cmd==0)
                  CROSS=STCB_TRIGGER_Four;
               else
                  if(cmd==1)
                     CROSS=STCS_TRIGGER_Four;

               // define variables for CMD
               if(cmd==0)
                  METHOD=STCB_METHOD_Four;
               else
                  if(cmd==1)
                     METHOD=STCS_METHOD_Four;

               if(cmd==0)
                  APPLY=STCB_APPLY_Four;
               else
                  if(cmd==1)
                     APPLY=STCS_APPLY_Four;

               if(cmd==0)
                  DIVISOR=STCB_DIVISOR_Four;
               else
                  if(cmd==1)
                     DIVISOR=STCS_DIVISOR_Four;

               if(cmd==0)
                  SHORT=STCB_SHORT_Four;
               else
                  if(cmd==1)
                     SHORT=STCS_SHORT_Four;

               if(cmd==0)
                  LONG=STCB_LONG_Four;
               else
                  if(cmd==1)
                     LONG=STCS_LONG_Four;

               if(cmd==0)
                  CYCLE=STCB_CYCLE_Four;
               else
                  if(cmd==1)
                     CYCLE=STCS_CYCLE_Four;

               if(cmd==0)
                  LEVEL=STCB_LEVEL_Four;
               else
                  if(cmd==1)
                     LEVEL=STCS_LEVEL_Four;
              }

            // for ind settings 5
            else
               if(indN == 5)
                 {
                  if(cmd==0)
                     CROSS=STCB_TRIGGER_Five;
                  else
                     if(cmd==1)
                        CROSS=STCS_TRIGGER_Five;
                  // define variables for CMD
                  if(cmd==0)
                     METHOD=STCB_METHOD_Five;
                  else
                     if(cmd==1)
                        METHOD=STCS_METHOD_Five;

                  if(cmd==0)
                     APPLY=STCB_APPLY_Five;
                  else
                     if(cmd==1)
                        APPLY=STCS_APPLY_Five;

                  if(cmd==0)
                     DIVISOR=STCB_DIVISOR_Five;
                  else
                     if(cmd==1)
                        DIVISOR=STCS_DIVISOR_Five;

                  if(cmd==0)
                     SHORT=STCB_SHORT_Five;
                  else
                     if(cmd==1)
                        SHORT=STCS_SHORT_Five;

                  if(cmd==0)
                     LONG=STCB_LONG_Five;
                  else
                     if(cmd==1)
                        LONG=STCS_LONG_Five;

                  if(cmd==0)
                     CYCLE=STCB_CYCLE_Five;
                  else
                     if(cmd==1)
                        CYCLE=STCS_CYCLE_Five;

                  if(cmd==0)
                     LEVEL=STCB_LEVEL_Five;
                  else
                     if(cmd==1)
                        LEVEL=STCS_LEVEL_Five;
                 }

   return;
  }

//+------------------------------------------------------------------+
//| Check STC                                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool Check_STC(int indN, int w, int cmd)
  {

   int CROSS=0;
   int METHOD=0;
   int APPLY=0;
   double DIVISOR=0;
   int SHORT=0;
   int LONG=0;
   int CYCLE=0;
   double LEVEL=0;

// define parameters
   defineSTCParameters(indN, cmd, CROSS, METHOD, APPLY, DIVISOR, SHORT, LONG, CYCLE, LEVEL);

// if DISABLED
   if(CROSS==0)
      return(true);

// indicator from EA
   if(true)
     {
      CHull iHullShort, iHullLong;

      iHullShort.init(SHORT, DIVISOR);
      iHullLong.init(LONG, DIVISOR);

      // define INDICATOR's values
      double smconst = 2 / (1 + (double)CYCLE/2);

      // Create arrays
      double MA[], ST[], MCD_Arr[], MAHullShort[], MAHullLong[];

      //ArrayResize(MA, 2*MathMax(LONG, CYCLE)+2);

      ArrayResize(MA, iBars(Pair_Name, tf));
      ArraySetAsSeries(MA, true);
      ArrayResize(ST, iBars(Pair_Name, tf));
      ArraySetAsSeries(ST, true);
      ArrayResize(MCD_Arr, iBars(Pair_Name, tf));
      ArraySetAsSeries(MCD_Arr, true);

      ArrayResize(MAHullShort, iBars(Pair_Name, tf));
      ArraySetAsSeries(MAHullShort, true);
      ArrayResize(MAHullLong, iBars(Pair_Name, tf));
      ArraySetAsSeries(MAHullLong, true);

      int shift,counted_bars=0;
      double MCD, LLV=0, HHV=0, MA_Short, MA_Long, prev;
      int n, i, s;
      bool check_begin=false, check_begin_MA=false;

      if(iBars(Pair_Name, tf)<=LONG)
         return(false);

      //---- initial zero
      if(counted_bars<LONG+SHORT)
        {
         for(i=1; i<=MathMax(LONG, CYCLE); i++)
            MA[iBars(Pair_Name, tf)-i]=0.0;
         for(i=1; i<=MathMax(LONG, CYCLE); i++)
            ST[iBars(Pair_Name, tf)-i]=0.0;
        }

      //----
      //shift=iBars(SYM, TimeFrame)-counted_bars+LONG+1;
      //if (shift>iBars(SYM, TimeFrame)-LONG-1) shift=iBars(SYM, TimeFrame)-LONG-1;
      //shift=2*MathMax(LONG, CYCLE)+1;
      shift=iBars(Pair_Name, tf)-1;

      //shift=w+2;

      check_begin = false;
      check_begin_MA = false;
      n = 1;
      s = 1;


      // define HULL value
      if(METHOD == 4)
        {
         int x=iBars(Pair_Name, tf)-IndicatorCounted()+1;
         if(x>=iBars(Pair_Name, tf))
            x=iBars(Pair_Name, tf)-1;

         for(; x>=0 && !_StopFlag; x--)
           {
            MAHullShort[x] = iHullShort.calculate(iMA(NULL,0,1,0,MODE_SMA,APPLY,x),iBars(Pair_Name, tf)-x-1,iBars(Pair_Name, tf));
            MAHullLong[x] = iHullLong.calculate(iMA(NULL,0,1,0,MODE_SMA,APPLY,x),iBars(Pair_Name, tf)-x-1,iBars(Pair_Name, tf));
           }
        }


      while(shift>=0)
        {
         // define HULL value
         if(METHOD == 4)
           {
            MA_Short = MAHullShort[shift];
            MA_Long = MAHullLong[shift];
           }
         // another case
         else
           {
            MA_Short = iMA(Pair_Name, tf, SHORT, 0, (int)METHOD, APPLY, shift);
            MA_Long = iMA(Pair_Name, tf, LONG, 0, (int)METHOD, APPLY, shift);
           }

         //MA_Short = iMA(Pair_Name, tf, SHORT, 0, METHOD, APPLY, shift);
         //MA_Long = iMA(Pair_Name, tf, LONG, 0, METHOD, APPLY, shift);


         MCD_Arr[n] = MA_Short - MA_Long;
         MCD = MA_Short - MA_Long;

         if(n >= CYCLE)
           {
            n = 1;
            check_begin = true;
           }
         else
           {
            n = n + 1;
           }

         if(check_begin)
           {
            for(i = 1; i<=CYCLE; i++)
              {
               if(i == 1)
                 {
                  LLV = MCD_Arr[i];
                 }
               else
                 {
                  if(LLV > MCD_Arr[i])
                     LLV = MCD_Arr[i];
                 }

               if(i == 1)
                 {
                  HHV = MCD_Arr[i];
                 }
               else
                 {
                  if(HHV < MCD_Arr[i])
                     HHV = MCD_Arr[i];
                 }
              }

            //ST[shift] = ((MCD - LLV)/(HHV - LLV))*100 + 0.01;
            // check for ZERO
            if(HHV - LLV != 0.0)
               ST[shift] = ((MCD - LLV)/(HHV - LLV))*100 + 0.01;
            else
               ST[shift] = 0.0;

            s = s + 1;
            if(s >= ((double)CYCLE)/2)
              {
               s = 1;
               check_begin_MA = true;
              }
           }
         else
           {
            ST[shift] = 0;
           }
         if(check_begin_MA)
           {
            prev = MA[shift + 1];
            MA[shift] = smconst * (ST[shift] - prev) + prev;
           }

         shift--;
        }

      //Print("STC: w1=", NormalizeDouble(MA[w+1], 5), ", w2=", NormalizeDouble(MA[w+2], 5));

      // check value
      // for RISE or FALL
      if(CROSS==2)
        {
         if(cmd==0 && MA[w+1]>LEVEL && MA[w+1]>=MA[w+2])
            return(true);
         else
            if(cmd==1 && MA[w+1]<LEVEL && MA[w+1]<=MA[w+2])
               return(true);
            else
               return(false);
        }
      // for just LEVEL
      else
         if(CROSS==1)
           {
            if(cmd==0 && MA[w+1]>LEVEL)
               return(true);
            else
               if(cmd==1 && MA[w+1]<LEVEL)
                  return(true);
               else
                  return(false);
           }
         else
            return(false);

     } // END of IND FROM EA

// iCustom
   else
     {


      double v1=0;
      double v2=0;

      //Print("v1=", v1, ", v2=", v2);

      // check value
      if(CROSS==1 || CROSS==2)
        {
         if(cmd==0 && v1==1)
            return(true);
         else
            if(cmd==1 && v2==1)
               return(true);
            else
               return(false);
        }
      // if disabled
      else
         return(true);



     } // END of iCustom


  }


/////////////////////////////////////////////////////////////////
///////////////////    HULL MA calculation //////////////////////
/////////////////////////////////////////////////////////////////
class CHull
  {
private :
   int               m_fullPeriod;
   int               m_halfPeriod;
   int               m_sqrtPeriod;
   int               m_arraySize;
   double            m_weight1;
   double            m_weight2;
   double            m_weight3;
   struct sHullArrayStruct
     {
      double         value;
      double         value3;
      double         wsum1;
      double         wsum2;
      double         wsum3;
      double         lsum1;
      double         lsum2;
      double         lsum3;
     };
   sHullArrayStruct  m_array[];

public :
                     CHull() : m_fullPeriod(1), m_halfPeriod(1), m_sqrtPeriod(1), m_arraySize(-1) {                     }
                    ~CHull()                                                                      { ArrayFree(m_array); }

   ///
   ///
   ///

   bool              init(int period, double divisor)
     {
      m_fullPeriod = (int)(period>1 ? period : 1);
      m_halfPeriod = (int)(m_fullPeriod>1 ? m_fullPeriod/(divisor>1 ? divisor : 1) : 1);
      m_sqrtPeriod = (int) MathSqrt(m_fullPeriod);
      m_arraySize  = -1;
      m_weight1 = m_weight2 = m_weight3 = 1;
      return(true);
     }

   //
   //
   //

   double            calculate(double value, int i, int bars)
     {
      if(m_arraySize<bars)
        {
         m_arraySize = ArrayResize(m_array,bars+500);
         if(m_arraySize<bars)
            return(0);
        }

      //
      //
      //

      //int k=0, w1, w2, w3;

      //Print("i = ", i, ", value = ", value);
      m_array[i].value=value;

      if(i>m_fullPeriod)
        {
         m_array[i].wsum1 = m_array[i-1].wsum1+value*m_halfPeriod-m_array[i-1].lsum1;
         m_array[i].lsum1 = m_array[i-1].lsum1+value-m_array[i-m_halfPeriod].value;
         m_array[i].wsum2 = m_array[i-1].wsum2+value*m_fullPeriod-m_array[i-1].lsum2;
         m_array[i].lsum2 = m_array[i-1].lsum2+value-m_array[i-m_fullPeriod].value;
        }
      else
        {
         m_array[i].wsum1 = m_array[i].wsum2 =
                               m_array[i].lsum1 = m_array[i].lsum2 = m_weight1 = m_weight2 = 0;
         for(int k=0, w1=m_halfPeriod, w2=m_fullPeriod; w2>0 && i>=k; k++, w1--, w2--)
           {
            if(w1>0)
              {
               m_array[i].wsum1 += m_array[i-k].value*w1;
               m_array[i].lsum1 += m_array[i-k].value;
               m_weight1        += w1;
              }
            m_array[i].wsum2 += m_array[i-k].value*w2;
            m_array[i].lsum2 += m_array[i-k].value;
            m_weight2        += w2;
           }
        }
      m_array[i].value3=2.0*m_array[i].wsum1/m_weight1-m_array[i].wsum2/m_weight2;

      //
      //---
      //

      if(i>m_sqrtPeriod)
        {
         m_array[i].wsum3 = m_array[i-1].wsum3+m_array[i].value3*m_sqrtPeriod-m_array[i-1].lsum3;
         m_array[i].lsum3 = m_array[i-1].lsum3+m_array[i].value3-m_array[i-m_sqrtPeriod].value3;
        }
      else
        {
         m_array[i].wsum3 =
            m_array[i].lsum3 = m_weight3 = 0;
         for(int k=0, w3=m_sqrtPeriod; w3>0 && i>=k; k++, w3--)
           {
            m_array[i].wsum3 += m_array[i-k].value3*w3;
            m_array[i].lsum3 += m_array[i-k].value3;
            m_weight3        += w3;
           }
        }
      return(m_array[i].wsum3/m_weight3);
     }
  };


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime GetLastBullishAfterBearish(int maxCandles)
  {
   bool bearishFound = false;
   double lastBullishPrice = 0.0;
   for(int i = 2; i <= maxCandles; i++)
     {
      if(Close[i+1] <= Open[i+1] && Close[i] > Open[i])    // Bearish candle
        {
         lastBullishPrice = Time[i]; // Store the price of the bullish candle
         break; // Stop scanning after finding the first bullish candle
        }
     }
   return lastBullishPrice;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime GetLastBearishAfterBearish(int maxCandles)
  {
   bool bearishFound = false;
   double lastBullishPrice = 0.0;
   for(int i = 2; i <= maxCandles; i++)
     {
      if(Close[i+1] >= Open[i+1] && Close[i] < Open[i])    // Bearish candle
        {
         lastBullishPrice = Time[i]; // Store the price of the bullish candle
         break; // Stop scanning after finding the first bullish candle
        }
     }
   return lastBullishPrice;
  }
//+------------------------------------------------------------------+
